#ifndef COMPOSITE_INPUTBOX_H
#define COMPOSITE_INPUTBOX_H

#include "../../podo/podo.h"
#include "ButtonCanvas.h"

namespace podo {namespace custom {namespace simple {

		typedef Panel<FlowLayoutManager< > > FlowPanel;

		class InputBox;
		typedef boost::shared_ptr<InputBox> InputBoxPtr;
		class InputBox: public FlowPanel{
			

		public:

			// enum ̿ؼ   Ҿµ.. 
			//enum ==  񱳰 ȵǴ װ ־ int  Ѵ.
			typedef int  Result;// {

			static const int	IB_OK  = 0;
			static const int	IB_CANCEL = 1;
			static const int	IB_CLOSE = 1;
			static const int	IB_NO = 2;
			static const int	IB_YES = 3;
			static const int	IB_NONE = 323;// ´  θ   ...
			


		private:
			Result _result;

			void close(Result result) {

				setResult(result);       
				
				TopWindowClientComponentMatcher::accessTopWindow  (*this).postDestroyRequestMessage ();
				

			}

		public:

			Result getResult () {
                assertExp(_result != IB_NONE);
				if(_result == IB_NONE){
					_result = IB_CANCEL;
				}
				return _result;
			}

			void setResult (Result result) {
				assertExp(result != IB_NONE);
				assertExp(_result == IB_NONE);
				 _result = result;
			}
			InputBox():
				_result(IB_NONE) {



			}

		
			
			class InputBoxComponentListener :public ComponentListener ,public InnerClass<InputBox>{
			
			public:            

				InputBoxComponentListener(InputBox & inpubBox	):InnerClass<InputBox>(inpubBox){
					
				}
				virtual bool const isComponentCloseOk(ComponentListenerHaver & sender, ComponentEventComponentCloseOk & event )  {

					_this.setResult(InputBox::IB_CLOSE);     
					return true;
				}
			};



			class OKButton : public Button,public InnerClass<InputBox>,public ActionListener{
				
			public:            

				OKButton(	InputBox & inpubBox):
					InnerClass<InputBox>(inpubBox),
					Button(new simple::ButtonCanvas ){

						this->accessChooseData().addActionListener(new ActionThisListener(*this));
						this->accessWStringData().setWString(WString(L"Ok"));
				}

				virtual void actionPerformed(ActionListenerHaver & sender, ActionEventActionPerformed & event) {				
					_this.close(InputBox::IB_OK);
				}


			};



		

			
			class CancelButton : public Button,public InnerClass<InputBox>,public ActionListener{
				
			public:            

				CancelButton(	InputBox & inpubBox):
					InnerClass<InputBox>(inpubBox),
					Button(new simple::ButtonCanvas() ){

						this->accessChooseData().addActionListener(new ActionThisListener(*this));
						this->accessWStringData().setWString(WString(L"Cancel"));
				}

				virtual void actionPerformed(ActionListenerHaver & sender, ActionEventActionPerformed & event) {					                
					_this.close(InputBox::IB_CANCEL);
				}


			};

			

			class YesButton : public Button ,public InnerClass<InputBox>,public ActionListener{
			
			public:            

				YesButton(	InputBox & inpubBox):
					InnerClass<InputBox>(inpubBox),
					Button(new simple::ButtonCanvas() ){

						this->accessChooseData().addActionListener(new ActionThisListener(*this));
						this->accessWStringData().setWString(WString(L"Yes"));
					
				}


				virtual void actionPerformed(ActionListenerHaver & sender, ActionEventActionPerformed& event) {
					             
					_this.close(InputBox::IB_YES );
				}

			};
			

			class NoButton : public Button ,public InnerClass<InputBox>,public ActionListener{
				
			public:            

				NoButton(	InputBox & inpubBox ):
					InnerClass<InputBox>(inpubBox),
					Button(new simple::ButtonCanvas ){

					this->accessChooseData().addActionListener(new ActionThisListener(*this));
					this->accessWStringData().setWString(WString(L"No"));
					
				}

				virtual void actionPerformed(ActionListenerHaver & sender, ActionEventActionPerformed & event) {
				              
					_this.close(InputBox::IB_NO);
				}

			};




		public:

			
				class MyCanvas :public Canvas{


					void paint(CanvasHaver & sender,InOutGraphics & graphics_r)  {
						try {

							Component & component = dynamic_cast<Component & >(sender);
							
							Rect rect(Point(0,0),component.getSize ());

							graphics_r.setBrush(Brush(Color(UInt8(233),UInt8(233),UInt8(233))));
							graphics_r.fillRect(rect);

						}catch(std::exception & e) {

							assertExp(false);

						}


					}



				};


			
			static Result showYesNo(Component & component,WString const & caption, WString const & detail)  {

				InputBoxPtr inputBox (new InputBox());

				inputBox ->setCanvas(new MyCanvas());
				inputBox ->setComponentListener(new InputBoxComponentListener(*inputBox));
				inputBox ->accessContentsPane().addComponent(new YesButton(*inputBox));
				inputBox ->accessContentsPane().addComponent(new NoButton(*inputBox));


				

					
				Application::instance().pushModalWindow(
					ModalWindow::build(static_cast<OwnerWindow&>(TopWindowClientComponentMatcher::accessTopWindow(component)),
					Point(300,200),Size(300,200),inputBox) 
					);


				
				return 	inputBox->getResult() ;
				

				


			}
			static Result showOk(Component & component,WString const & caption, WString const & detail) {
			
				InputBoxPtr inputBox (new InputBox());

				inputBox ->setCanvas(new MyCanvas());
				inputBox ->setComponentListener(new InputBoxComponentListener(*inputBox));
				inputBox ->accessContentsPane().addComponent(new OKButton(*inputBox));
		

					
				Application::instance().pushModalWindow(
					ModalWindow::build(static_cast<OwnerWindow&>(TopWindowClientComponentMatcher::accessTopWindow(component)),
					Point(300,200),Size(300,200),inputBox) 
					);
				return 	inputBox->getResult() ;


			}
			static Result showYesNoCancel(Component & component,
				WString const & caption, WString const & detail) {
				
				InputBoxPtr inputBox (new InputBox());

				inputBox ->setCanvas(new MyCanvas());
				inputBox ->setComponentListener(new InputBoxComponentListener(*inputBox));
				inputBox ->accessContentsPane().addComponent(new YesButton(*inputBox));
				inputBox ->accessContentsPane().addComponent(new NoButton(*inputBox));
				inputBox ->accessContentsPane().addComponent(new CancelButton(*inputBox));

					
					
				Application::instance().pushModalWindow(
					ModalWindow::build(static_cast<OwnerWindow&>(TopWindowClientComponentMatcher::accessTopWindow(component)),
					Point(300,200),Size(300,200),inputBox) 
					);


				return 	inputBox->getResult() ;

			}
			static Result input(Component & component,WString const & caption, WString const & detail,int32_t & inoutValue){
				
				InputBoxPtr inputBox (new InputBox());

				inputBox ->setCanvas(new MyCanvas());
				inputBox ->setComponentListener(new InputBoxComponentListener(*inputBox));
				inputBox ->accessContentsPane().addComponent(new YesButton(*inputBox));
				inputBox ->accessContentsPane().addComponent(new NoButton(*inputBox));

					
					
				Application::instance().pushModalWindow(
					ModalWindow::build(static_cast<OwnerWindow&>(TopWindowClientComponentMatcher::accessTopWindow(component)),
					Point(300,200),Size(300,200),inputBox) 
					);


				return 	inputBox->getResult() ;


			}



		};


		
			 
}}}




	
#endif 
//COMPOSITE_INPUTBOX_H

