#ifndef PODO_CUSTOM_SIMPLE_MENUBAR_H
#define PODO_CUSTOM_SIMPLE_MENUBAR_H

#include "../../podo/podo.h"

namespace podo {namespace custom {namespace simple {

	
	class MenuBar :public Panel<XyLayoutManager > {


		class PopupActionListenerBottom: public ActionListener {

			PopupMenuItem & _popupMenuItem;
			boost::shared_ptr< PopupContainer > _popupContainer;
			

		public:
			PopupActionListenerBottom(PopupMenuItem & popupMenuItem,boost::shared_ptr< PopupContainer > popupContainer)
				:_popupMenuItem (popupMenuItem),_popupContainer(popupContainer) {

			}
			virtual void actionPerformed(ActionListenerHaver & sender, ActionEventActionPerformed & event) {
			
				//try {
					//Component & component = dynamic_cast<Component&> (sender);

				trace("\nAction");	

				
				Rect rectOnClient		 = _popupMenuItem.getRectOnClient();
				

				Point bottomLeftPointOnClient = Point(rectOnClient.getX (),rectOnClient.getNextY ());


				TopWindow & topWindow =
					TopWindowClientComponentMatcher::accessTopWindow(	ComponentChainUtil::accessClientComponent(_popupMenuItem) );


				Point bottomLeftPointOnBackground = topWindow.clientToBackground( bottomLeftPointOnClient);

	            

				PopupContainer::popup(bottomLeftPointOnBackground,_popupContainer,PopupContainer::SOUTH_EAST);	

				
			}
		};

	
	public :


		
	



		void addMenuItem(MenuItem* menu  ) {
			addMenuItem(MenuItemPtr(menu) );     
		}

		
		void addMenuItem(MenuItemPtr menu ) {
			accessContentsPane().addComponent(menu,Rect( static_cast<int32_t>(accessContentsPane().childSize() * 100) ,0,100,20) );  
		}

	


		
		void addPopupMenuItem(PopupMenuItem * popupMenu  ) {
			addPopupMenuItem(PopupMenuItemPtr(popupMenu));			 
		}				


		void addPopupMenuItem(PopupMenuItemPtr popupMenu) {				
			accessContentsPane().addComponent(popupMenu,Rect( static_cast<int32_t>(accessContentsPane().childSize() * 100) ,0,100,20) );
		}


		template <typename ChooseTextItemAbstractCanvasPPP>
		static shared_ptr<PopupMenuItem> buildPopupMenu(ChooseTextItemAbstractCanvasPPP menuCanvas,WString const & wstr,PopupContainerPtr container) {
			PopupMenuItem *item = new PopupMenuItem(menuCanvas,wstr);
			item->accessNormalChooseData().addActionListener(new PopupActionListenerBottom ( *item, container ));

			return  shared_ptr<PopupMenuItem>(item);
		}






	};

	typedef boost::shared_ptr<MenuBar> MenuBarPtr;

}}}

#endif
//PODO_CUSTOM_SIMPLE_MENUBAR_H

