/* Generated by Together */

#ifndef SCROLLPANE_H
#define SCROLLPANE_H

#include "../../podo/podo.h"
#include "VerticalScrollCanvas.h"
#include "HorizontalScrollCanvas.h"


namespace podo { namespace custom {namespace simple {



	typedef BorderLayoutManager<20> BorderLayoutManagerSP;
	typedef Panel<BorderLayoutManagerSP > BorderPanel;


        class ScrollPane : public BorderPanel, public ScrollView {
			typedef ScrollPane this_t;
			
			//Ʈ ο XyPanel 1 ξ   Ҵ..
			//XyPanel ߾ӿ ġ ϱ  ũⰡ ڵ Ѵ.

			//XyPanel   Scroll Page ȴ..
			// Ʈ ġ Scroll Point Ǹ
			// Ʈ  Scroll Max ȴ.

			//Scroll Ÿ ȭ ߴ  
			//XyPanel  ϸ ScrollData  Ų..
			//ũѿ ScrollData Ű⵵ Ѵ.

			//ScrollData  Point Ʈ ݿѴ. 

			typedef Panel<XyLayoutManager> XyPanel;
			typedef boost::shared_ptr<XyPanel> XyPanelPtr;
			

			class ScrollPaneCanvas :public Canvas{
				virtual void paint(CanvasHaver  & sender,InOutGraphics & graphics_r)  {

					ScrollPane & scrollPane = static_cast<ScrollPane &>(sender);

					graphics_r.setBrush(Brush(Color(UInt8(255),UInt8(255),UInt8(255))));

					graphics_r.fillRect(Rect(Point(),scrollPane.getSize() ));


				}
			};


			
			struct ScrollPaneSizeListener :public SizeListener {
				this_t &_this;
				ScrollPaneSizeListener(this_t & this_r):_this(this_r) {

				}
				virtual void sizeChanged(SizeListenerHaver &sender, SizeEventSizeChanged &event ) {
					Size xySize = (*_this._xyPanel).getSize(); 
			
					_this.shareVerticalScrollData()->setPage(xySize .getHeight());		
					_this.shareHorizontalScrollData()->setPage(xySize .getWidth());
				}
			};

			friend struct ScrollPaneSizeListener;


        private:
           
           

            XyPanelPtr _xyPanel;
			

        public:
            
            ScrollPane():_xyPanel(XyPanelPtr (new XyPanel()) ) { 



							

                addSizeListener(new ScrollPaneSizeListener(*this));	           
				accessContentsPane().addComponent(createVerticalScroll(),BorderLayoutManagerSP::EAST);	
				accessContentsPane().addComponent(createHorizontalScroll(),BorderLayoutManagerSP::SOUTH);		
				accessContentsPane().setComponent(_xyPanel,BorderLayoutManagerSP::CENTER);




				shareVerticalScrollData()->addView(*this);
				shareHorizontalScrollData()->addView(*this);

				


				setCanvas(new ScrollPaneCanvas());



			
			}

            virtual ~ScrollPane() { 

				shareVerticalScrollData()->subView(*this);
				shareHorizontalScrollData()->subView(*this);
			
			
			}
            
			void setInnerComponent(Component * initComp, Size const & initComponentSize) {	    
				ComponentPtr temp(initComp);
				setInnerComponent(temp, initComponentSize);
			}
            void setInnerComponent(ComponentPtr initInnerComp, Size const & initComponentSize){ 
			

			assertExp( !hasInnerComponent() );//removeInnerComponent  ȣ ض...

				if(hasInnerComponent() ){
					removeInnerComponent();
				}

	            
				_xyPanel->accessContentsPane().addComponent(initInnerComp,Rect(Point(),initComponentSize));
				

				
				shareVerticalScrollData()->setMaybeMax(initComponentSize.getHeight());		
				shareHorizontalScrollData()->setMaybeMax(initComponentSize.getWidth());		
				

			
				
			}
            void removeInnerComponent(){
			

				assertExp( hasInnerComponent() );
				_xyPanel->accessContentsPane().clear();		

				this->shareHorizontalScrollData()->setMaybeMax(0);
				this->shareVerticalScrollData()->setMaybeMax(0);

								
			}

            ComponentPtr shareInnerComponent(){

				assertExp(hasInnerComponent());		

				return _xyPanel->accessContentsPane().shareChildComponent(0);

			}
           
            bool hasInnerComponent() {
				bool result = (_xyPanel->accessContentsPane().childSize() != 0) ;

				return result;
			}
            virtual void scrollDataChanged(ScrollData const & scrollData_r){ 

				//Only Change Pos 

				if(! hasInnerComponent() ) {
					return;
				}


				Rect oldRt = ( *shareInnerComponent()).getRectOnParent();
				Rect newRt = oldRt;

				if( &scrollData_r == this->shareVerticalScrollData() .get()) {

					newRt.setY(- static_cast<int32_t>(scrollData_r.computePos()));	

				}
				else if (&scrollData_r == this->shareHorizontalScrollData() .get()) {	

					newRt.setX(- static_cast<int32_t>(scrollData_r.computePos()));					
					
				}
				else {
					assertExp(false);
					return;
				}

				size_t index = 0;
				_xyPanel->accessContentsPane().moveComponent(	index , newRt);
				if(ComponentChainUtil::isChainOk(*_xyPanel) ) {
					_xyPanel->repaint();
				}
			
			}

          
			VerticalScroll * createVerticalScroll(){
		
				VerticalScrollAbstractCanvas * verticalCanvas =  new VerticalScrollCanvas();			
				VerticalScrollAbstractCanvasPtr verticalCanvas_p(verticalCanvas);
				
			
				VerticalScroll   * verticalScroll = new VerticalScroll(verticalCanvas_p);			
				return verticalScroll;
			}

			HorizontalScroll * createHorizontalScroll() {

		
				HorizontalScrollAbstractCanvas * horizontalCanvas =new  HorizontalScrollCanvas();		
				HorizontalScrollAbstractCanvasPtr horizontalCanvas_p(horizontalCanvas);
			
				HorizontalScroll * horizontalScroll = new HorizontalScroll(horizontalCanvas_p);
				return horizontalScroll;


			}


protected:

           

public:

			ScrollDataPtr shareVerticalScrollData(){

				ComponentPtr component = accessContentsPane().shareComponent(BorderLayoutManagerSP::EAST );
				VerticalScrollPtr scroll = boost::static_pointer_cast<VerticalScroll>(component);
				return scroll->getScrollData();


			}
			ScrollDataPtr shareHorizontalScrollData() {
				ComponentPtr component = accessContentsPane().shareComponent(BorderLayoutManagerSP::SOUTH );
				HorizontalScrollPtr scroll = boost::static_pointer_cast<HorizontalScroll>(component);
				return scroll->getScrollData();

			}



        };

    
}}}



#endif
//SCROLLPANE_H
