
#include "../../podo/podo.h"

#include "../../custom/simple/MenuBar.h"
#include "../../custom/simple/ButtonCanvas.h"


int podo::main() {

	using namespace podo;	

	typedef Panel<BorderLayoutManager<20> > BorderPanel ;
	typedef boost::shared_ptr<BorderPanel> BorderPanelPtr;
	
	using namespace podo::custom::simple;
	using namespace podo::wrapper;


	PopupMenuPtr  menu1_2(new PopupMenu);
	menu1_2->addMenu(new ButtonCanvas,WString(L"Menu 1-2-1"));
	menu1_2->addMenu(new ButtonCanvas,WString(L"Menu 1-2-2") );
	

	PopupMenuPtr  menu1(new PopupMenu);

	menu1->addMenu(new ButtonCanvas,WString(L"Menu 1-1"));
	menu1->addPopupMenu(menu1_2,new ButtonCanvas,WString(L"Menu 1-2"));
	menu1->addMenu(new ButtonCanvas,WString(L"Menu 1-3"));


	MenuBarPtr menuBar(new MenuBar);
	menuBar->addPopupMenu(menu1,new ButtonCanvas,WString(L"Menu 1")  );
	menuBar->addMenu(new ButtonCanvas,WString(L"Menu 2") );



	BorderPanelPtr topComponent(new BorderPanel());
	topComponent->accessContentsPane().
		addComponent(menuBar, BorderLayoutManager<20> ::NORTH); 

	podo::FrameWindowPtr frameWindow = podo::FrameWindow::build (Point(0,2),Size(300,200), topComponent  );	
	Application::instance().registFrameWindow(frameWindow);

	
	return Application::instance().run();
}














