#ifndef DEPENDINFOCOMPUTER_H_
#define DEPENDINFOCOMPUTER_H_


#ifdef min
	#undef min
#endif 

#include "Module.h"

typedef std::map<File , FileList > DependInfo;


class DependInfoComputer{

	

public:




static void initDependInfo(DependInfo & dependInfo, FileList & filesInModule){

	for(FileList::iterator i = filesInModule.begin() ; i != filesInModule.end()  ; ++ i) {
		dependInfo[ *i ].insert( *i );

	}
}

static void  appendList(FileList & dependList, FileList & includeList) {

	
	dependList.insert(includeList.begin(), includeList.end());
}



 static FileList getIncludeList(File const  &file ) {


	FileList result;

	char buf[255];

	std::ifstream fin(file.string().c_str ());

	while( fin.getline (buf,250) ) {
		int parsingLevel = 0;


		int index = 0;
		int beginIndex = 0;
		int endIndex = 0;
		

		if(buf[0] == '#' && 
			buf[1] == 'i' && 
			buf[2] == 'n'&& 
			buf[3] == 'c'&&
			buf[4] == 'l'&&
			buf[5] == 'u'&&
			buf[6] == 'd'&&
			buf[7] == 'e'){

				
			parsingLevel = 1;

		}
		
		if(parsingLevel != 1 ) {
			continue;
		}		


		for(index = 8 ; index <  std::min<int>(strlen(buf), 240)  ; ++index) {
			if(buf[index] == '"') {
				beginIndex = index + 1;
				parsingLevel = 2;
				break;
			}
		}

		if(parsingLevel != 2 ) {
			continue;
		}	


		for(index = beginIndex  ; index < std::min<int>(strlen(buf), 240)  ; ++index) {
			if(buf[index] == '"') {
				endIndex = index ;
				parsingLevel = 3;
				break;
			}
		}

		if(parsingLevel != 3 ) {
			continue;
		}	


		std::string filename = std::string(&buf[beginIndex],&buf[endIndex]);
		boost::filesystem::path directory = file.branch_path();
        
		
		boost::filesystem::path includedPath = directory/filename;	
		if(File::isFile(includedPath)) {
			File fi(includedPath);
			result.insert(fi);

		}else {
			std::cout <<std::endl << includedPath.string() << "is Not Legal File But Included ";

		}
		
		

		

		
		
	
	}

	


	return result;
}

static void basicDependInfo(DependInfo & dependInfo){

	for(DependInfo::iterator iter = dependInfo.begin() ; iter != dependInfo.end()  ; ++ iter) {


		FileList & dependList = iter->second ;
		FileList includeList = getIncludeList( iter->first );

		appendList(dependList, includeList);
	}
}


static bool  updateDepend(DependInfo & dependInfo) {

	bool bChanged = false;
	//⼭ ͷʹ  ȿȭ  ʴ´  ̻ Ұ ߰  ʱ ̴..
	for(DependInfo::iterator iter = dependInfo.begin() ; iter != dependInfo.end() ; ++iter) {

		FileList & dependList = iter ->second;
		FileList const  dependListCopy = dependList;


		for(FileList::const_iterator iterDependCopy = dependListCopy
		.begin() ;
			iterDependCopy != dependListCopy.end(); ++iterDependCopy) {
			appendList(dependList,dependInfo[*iterDependCopy]);
		}


		bChanged = (bChanged && (dependList.size() != dependListCopy.size()));

	}

	return bChanged;
}


static DependInfo getDependInfo(FileList & filesInModule) {

	DependInfo dependInfo;

	initDependInfo(dependInfo,filesInModule);
	basicDependInfo(dependInfo);

	while(updateDepend (dependInfo )) {
	}

	return dependInfo;
}




};


#endif //DEPENDINFOCOMPUTER_H_
