#ifndef PATH_UTIL_H_
#define PATH_UTIL_H_


#include "FileUtil.h"
	
#include <vector>
#include <string>
#include <boost/filesystem/operations.hpp>
#include <boost/filesystem/path.hpp>

typedef std::vector<std::string> Elements ;

class PathUtil {



private:

	static Elements getElements(boost::filesystem::path const &target) {

		boost::filesystem::path temp =  boost::filesystem::complete(target );

		Elements result;


		result.insert(result.begin(),temp.leaf());	
		while(temp.has_branch_path() ){		
			temp = temp.branch_path ();
			std::string dfd= temp.leaf();
			result.insert(result.begin(),temp.leaf());
		}

		

		return result;

	}


	static std::string const  compareRelatePath(LegalDirectory const & origin,
		LegalDirectory const &target ,
		std::string const & seprator = std::string("/")  ) {




		Elements oriEle = getElements(origin.getPath());
		Elements tarEle = getElements(target.getPath());

		int oriDep = oriEle.size();
		int tarDep = tarEle.size();
		int commonDep = 0;

		for(int i = 0; i < std::min(oriDep,tarDep) ; ++i ) {

			if(oriEle [i] == tarEle[i]) {
				commonDep = i + 1  ;
			}else {
				break;
			}
		}


		std::string before;

		for(int i = 0 ; i < (oriDep - commonDep ); ++ i) {
			before += "..";
			before += seprator;

		}
		

		std::string after;
		for(int i = commonDep ; i < tarDep ; ++ i) {
			after += tarEle[i];
			after +=  seprator;
		}

		std::string result = before + after;
		

		return result;

	}



public:
	static std::string const relatePath(LegalDirectory const &target,
		LegalDirectory const & origin = LegalDirectory(boost::filesystem::initial_path()), 
		std::string const & seprator = std::string("/")  ) {


		return compareRelatePath(origin,target,seprator) ;       

		

	}


	



};

#endif 
 //	 PATH_UTIL_H_


