


#include <stdio.h>
#include <windows.h>
#include <string>
#include <vector>
#include <fstream>
#include <sys/stat.h>
#include <algorithm>



#include "../PathUtil.h"
#include "../FileUtil.h"
#include "../Project.h"


#include <iostream>

using namespace std;
using namespace boost;


struct PathMoum {
	static 	std::string podoLibPath() {
			return "../../podo";
		}

	static 	std::string podoCustomPath() {
			return "../../custom";
		}

};





int filecountInDirectoryRecusive(LegalDirectory const & directory) {


	int result = 0;

	fs::directory_iterator end_itr;
	for(fs::directory_iterator dir_itr (directory.getPath()) ; dir_itr != end_itr; ++dir_itr) {

		fs::path subPa = *dir_itr;
		if(fs::is_directory(subPa) ) {
			if(subPa.leaf() == std::string("CVS")) {
				continue;
			}
			result += filecountInDirectoryRecusive(subPa);
		}else {
			File file(subPa);

			if(file.is_ext (buildExtents("p","h","cpp")) ){
				result++;
			}
			else {
				//none;
			}
		}
	}    

	return result;

}

void writeDirectoryRecusive(LegalDirectory const &directory, LegalDirectory const & originPath   , ostream & os) {

	if(filecountInDirectoryRecusive(directory) == 0) {
		//none 
		return;
	}

	os <<"";
	os <<string( 2,'\t') <<"<Filter\n";			
	os <<string( 3,'\t') <<"Name=\"" << directory.getPath().leaf () <<"\"\n";
	os <<string( 3,'\t') <<"Filter=\"\">";
	os <<"\n";




    FileList files;		//use For to Allign File <= FileList is implemented By Sort;
	fs::directory_iterator end_itr;
	for(fs::directory_iterator dir_itr (directory.getPath()) ; dir_itr != end_itr; ++dir_itr) {

		fs::path subPa = *dir_itr;
		if(fs::is_directory(subPa) ) {
			if(subPa.leaf() == std::string("CVS")) {
				continue;
			}
			writeDirectoryRecusive(subPa,originPath,os);

		}else {
			File file(subPa);

			if(file.is_ext (buildExtents("p","h","cpp")) ){
				files.insert(file);
				


				
			}
			else {
				//none;
			}
		}
	}    




	for(FileList::iterator iter = files.begin() ; iter != files.end();++iter){

		os<<string(2,'\t') << "<File\n";
		os<<string( 3,'\t') << "RelativePath=\""<< PathUtil::relatePath (directory,originPath,std::string("\\") ) <<iter->leaf() <<"\">\n"	;
		os<<string( 2,'\t') << "</File>";
		os<<'\n';	
	}

	os<<string( 2,'\t') << "</Filter>\n";

}



void copyFile(path const & src, std::ofstream &fout_dst ) {
	
	ifstream fout_src(src.string().c_str());
	

	if(!fout_src.is_open () ){
		cout<<endl <<"error copyFile" <<"From :"<<src.string()<<"At: src Opening";

	}

	if(!fout_dst.is_open () ){
		cout<<endl <<"error copyFile" <<"From :"<<src.string()<<"At: dst Opening";

	}

	int count = 0;
	
	if(fout_src.is_open() ){ 
		 for(;;){
			int temp = fout_src.get();

			if(fout_src.eof())
				break;
			fout_dst.put(temp);
			count ++;
		}
	}
	fout_dst<<'\n';

	cout <<endl<<count <<"Copyed";

}




void writeLibProject() {


	ProjectDebugFactory fac;

	Project project  = fac.getProject(LegalDirectory(PathMoum::podoLibPath ()) );




	ofstream fout_src(project.getVcprjFile().string () .c_str());
	
	copyFile(path(string("head_lib")),fout_src);
   
	

	//FileList  files;

	
	//FileUtil::gather_recusive(PathMoum::podoLibPath () ,buildExtents("p","h","cpp"), files);
	


	writeDirectoryRecusive(LegalDirectory(PathMoum::podoLibPath () ),LegalDirectory(project.getVcprjDir ()),fout_src);
	writeDirectoryRecusive(LegalDirectory(PathMoum::podoCustomPath()) ,LegalDirectory(project.getVcprjDir ()),fout_src);
	
	

	
	

	
	
	copyFile(path(string("tail_lib")),fout_src);



}


void writeExeProject(path  prj_path) {

		

	
	ProjectDebugFactory fac;

	Project project  = fac.getProject(prj_path);


	



	std::string kjkj = project.getVcprjFile().string () ;

	
	ofstream fout_src(kjkj.c_str() );

	if(!fout_src.is_open()) {

		throw std::exception();
	}
	
	copyFile(path(string("head_exe")),fout_src);
   
	


	writeDirectoryRecusive(project.getDirectory() ,project.getVcprjDir (),fout_src);
	
	
	

	
	
	copyFile(path(string("tail_exe")),fout_src);


}


void writePrjProject(path  prj_path) {

		

	
	ProjectDebugFactory fac;

	Project project  = fac.getProject(prj_path);


	



	std::string kjkj = project.getVcprjFile().string () ;

	
	ofstream fout_src(kjkj.c_str() );

	if(!fout_src.is_open()) {

		throw std::exception();
	}
	
	copyFile(path(string("head_prj")),fout_src);
   
	

	writeDirectoryRecusive(project.getDirectory() ,project.getVcprjDir (),fout_src);
	
	

	
	

	
	
	copyFile(path(string("tail_prj")),fout_src);


}


void writeExampleProjects() {
	
	path examplePath("../../example");

	fs::directory_iterator iterEnd;
	fs::directory_iterator iter(examplePath);
	for( ; iter != iterEnd; ++iter) {

		if(boost::filesystem::is_directory(*iter)) {
			if(iter->leaf() == std::string("CVS")) {
				continue;
			}
			writeExeProject(*iter);

		}
	}






	//writeExampleProject ( / string("create_window"));


}





int main(int argc, char *argv[]) {



	writeLibProject();
	

	if(argc ==  1) {
		writeExampleProjects();
		return 0 ;
	}
	else {


		string project_name = string(argv[1]); 

		boost::filesystem::path prject_path(project_name);

		try {

            			
			
			if(!fs::exists( prject_path)) {
				std::cerr<<"Not Exists :"<<prject_path.string();
				return 0;
			}
			if(!fs::is_directory( prject_path) ) {

				std::cerr<<"Not Directory :"<< prject_path.string();
				return 0;

			}



		}catch(std::exception &e) {
			std::cerr<<e.what()<< prject_path.string();
			return 0;
		}



		writePrjProject(project_name);
	}


	
	


	return 0;

}



//

//

	//	Paths h_files;
	//	Paths cpp_files;

	//	try {	    
	//		gather_recusive(prj_path,Extent("h"),h_files);
	//		gather_recusive(prj_path,Extent("cpp"),cpp_files);
	//	}catch(std::exception &e) {

	//		std::cerr<<"exception At recusive"<<e.what();
	//			return 0;
	//	}


	//	
	//	Paths all_files;
	//	std::merge(h_files.begin(),h_files.end(),cpp_files.begin(),cpp_files.end(),std::back_inserter(all_files),Less());

	

