#ifndef ATTRIBUTEHAVER_H
#define ATTRIBUTEHAVER_H


#include <boost/shared_ptr.hpp>
#include "Debug.h"

namespace podo {



		template < typename ATTRIBUTE  >
		class AggregationAttribute {
		public:
			typedef  boost::shared_ptr <  ATTRIBUTE > ATTRIBUTEPTR  ;
		private:

			ATTRIBUTEPTR _attribute;


		public:

			AggregationAttribute() {

			}
			~AggregationAttribute() {
				assertExp( !has() );
				_attribute.reset();
			}


			bool const has()const {
				if (_attribute.get() != NULL) {
					return true;
				}

				return false;
			}

			void remove() {
				assertExp( has() );
				_attribute.reset();
			}


			void set(ATTRIBUTE * attribute) {
				ATTRIBUTEPTR temp(attribute);
				set (temp);
			}

			void set(ATTRIBUTEPTR attribute) {
				assertExp(!has());
				_attribute = attribute;
			}

			void replace(ATTRIBUTE * attribute) {
				ATTRIBUTEPTR temp(attribute);
				replace (temp);
			}

			void replace(ATTRIBUTEPTR attribute) {
				assertExp(attribute.get() != NULL);
				assertExp(has());
				_attribute = attribute;
			}


			ATTRIBUTEPTR share() {	
				assertExp(has());
				return _attribute;
			}

			ATTRIBUTE & access() {
				assertExp(has());
				return *_attribute;
			}

			ATTRIBUTE & operator *() {
				assertExp(has());
				return *_attribute;
			}

			ATTRIBUTEPTR operator ->() const {
				assertExp(has());
				return _attribute;
			}


			operator ATTRIBUTEPTR() const {
			//	assertExp(has());
				return _attribute;
			}





			
		};

}
	
#endif
//ATTRIBUTEHAVER_H


