#ifndef GLOBAL_INNERCLASS_H_
#define GLOBAL_INNERCLASS_H_

#include "Debug.h"

#include <set>

namespace podo {
	
	template <typename TH>
	class InnerClass {
	public:
		
	protected:
		TH & _this;
		InnerClass(TH & this_r):_this(this_r) {
	        
		}
	};


	template <typename View >
	struct Doc {

		typedef void (View::*ViewFunc )( ) ;

		ViewFunc _viewFunc;

		typedef std::set<View*> Views;
		Views _views;

		Doc(ViewFunc viewFunc):_viewFunc(viewFunc) {

		}

		~Doc() {
			assertExp(_views.size() == 0);
		}

		void registView(View & view) {
			assertExp(_views.find(&view) == _views.end());
			_views.insert(&view);

		}
		void unregistView(View & view) {
			assertExp(_views.find(&view) != _views.end());
			_views.erase(&view);
		}

		void broadcast() {

			typename Views::iterator iter = _views.begin() ;
			for(  ; iter != _views.end() ; ++iter) {

				View * view = *iter;
                

				(view->*_viewFunc)();

			}
		}

	};



	template <typename View,typename Arg1 >
	struct Doc1 {

		typedef void (View::*ViewFunc )(Arg1 ) ;

		ViewFunc _viewFunc;

		typedef std::set<View*> Views;
		Views _views;

		Doc1(ViewFunc viewFunc):_viewFunc(viewFunc) {

		}

		~Doc1() {
			assertExp(_views.size() == 0);
		}

		void registView(View & view) {
			assertExp(_views.find(&view) == _views.end());
			_views.insert(&view);

		}
		void unregistView(View & view) {
			assertExp(_views.find(&view) != _views.end());
			_views.erase(&view);
		}

		void broadcast(Arg1 arg) {

			typename Views::iterator iter = _views.begin() ;
			for(  ; iter != _views.end() ; ++iter) {

				View * view = *iter;
                

				(view->*_viewFunc)(arg);

			}
		}

	};
}

#endif
//GLOBAL_INNERCLASS_H_

