
#ifndef _INT8_H_
#define _INT8_H_

#include "Debug.h"
#include <iostream>




namespace podo{
	
		class Int8 {
		private:
			signed char ch;
			static int const MIN_BOUND = -127;
			static int const MAX_BOUND = 128;

		public:
			explicit Int8(signed char initCh) {
				ch = initCh;
			}

			explicit Int8(signed int initCh) {
				assertExp(MIN_BOUND <= initCh && initCh <= MAX_BOUND);
				
			}

			friend std::ostream & operator << (std::ostream & os, Int8 const & in) {

				os << static_cast < int const > (in.ch);
				return os;
			}

			friend Int8 operator + (Int8 const & left, Int8 const & right) {

				Int8 temp(left.ch);
				temp += right;

				return temp;
			}

			Int8 & operator += (Int8 const & right) {

				int tempLeft = ch;
				int tempRight = right.ch;

				int result = tempLeft + tempRight;
				assertExp(MIN_BOUND <= result && result <= MAX_BOUND);


				ch = static_cast < signed char > (result);

				return * this;
			}

			friend Int8 operator - (Int8 const & left, Int8 const & right) {

				Int8 temp(left.ch);
				temp -= right;

				return temp;
			}

			Int8 & operator -= (Int8 const & right) {

				int tempLeft = ch;
				int tempRight = right.ch;

				int result = tempLeft - tempRight;
				assertExp(MIN_BOUND <= result && result <= MAX_BOUND);


				ch = static_cast < signed char > (result);

				return * this;
			}



		};

	
     
}


#endif
//INT8_H_

