/* Generated by Together */

#ifndef KEY_H
#define KEY_H

#include "../system/SystemApi.h"


namespace podo{
	
		class KeyboardKey {
			friend class Shortcut;


		public:
			enum Virtualkey {
				VIRTUAL_NULL,
				VIRTUAL_A, VIRTUAL_B, VIRTUAL_C, VIRTUAL_D, VIRTUAL_E, VIRTUAL_F, VIRTUAL_G, 
				VIRTUAL_H, VIRTUAL_I, VIRTUAL_J, VIRTUAL_K, VIRTUAL_L, VIRTUAL_M, VIRTUAL_N,
				VIRTUAL_O, VIRTUAL_P, VIRTUAL_Q, VIRTUAL_R, VIRTUAL_S, VIRTUAL_T, VIRTUAL_U, 
				VIRTUAL_V, VIRTUAL_W, VIRTUAL_X, VIRTUAL_Y, VIRTUAL_Z, VIRTUAL_0, VIRTUAL_1,
				VIRTUAL_2, VIRTUAL_3, VIRTUAL_4, VIRTUAL_5, VIRTUAL_6, VIRTUAL_7, VIRTUAL_8, 
				VIRTUAL_9, VIRTUAL_SHIFT, VIRTUAL_CONTROL, 
				VIRTUAL_DEL,VIRTUAL_BACKSPACE,
				VIRTUAL_RETURN,VIRTUAL_SPACE,
				VIRTUAL_TAB,
				VIRTUAL_ESCAPE,
				VIRTUAL_PAGEDOWN,
				VIRTUAL_PAGEUP,
				VIRTUAL_HOME,
				VIRTUAL_END,
				VIRTUAL_LEFT,
				VIRTUAL_RIGHT,
				VIRTUAL_UP,
				VIRTUAL_DOWN

			};

		private:


			Virtualkey virtualkey;

			bool shift;
			bool control;
			bool alt;


		public:
			


			bool const &getShift() const {
				return shift;
			}

			bool const &getControl() const{

				return control;
			}

			bool const & getAlt() const {

				return alt;
			}

			static bool const  shiftPressed() {


#if defined (_PODO_WIN32)
				if((::GetKeyState(VK_SHIFT) >> 15) > 0){
					return true;
				}
				else {
					return false;
				}

#elif defined(_PODO_POSIX)

				return false;
#endif



			

			}



			

			Virtualkey const & getVirtualKey() const {

				return virtualkey;
			}

			bool const isUpperCase() const {
				return getShift();
			}		


			bool const operator == (KeyboardKey const&key)const {
				return (shift == key.shift) &&
					(control == key.control) &&
					(alt    == key.alt)     &&
					(virtualkey == key.virtualkey);            
			}

		

		//private:
			explicit KeyboardKey(Virtualkey initVK , bool shift , bool control , bool alt );


			};



	
}

#endif
//KEY_H

