#ifndef _POINT_H
#define _POINT_H

#include "Point.p"
#include "Basic.h"
#include "String.p"


namespace podo{
	 
		class Point {

		public:
			struct PointLess {

				bool operator() (Point const & pt1, Point const & pt2) {
					if (pt1.getX() < pt2.getX()) return true;
					if (pt1.getX() > pt2.getX()) return false;

					if (pt1.getY() < pt2.getY()) return true;

					return false;

				}
			};


		private:
			int32_t x;
			int32_t y;

		public:
			Point(int32_t inputX = 0, int32_t inputY = 0);

			//Point(uint32_t inputX , uint32_t inputY ){
			//	assertExp( inputX < 0xefffffff);
			//	assertExp( inputY < 0xefffffff);
			//	x = static_cast<int32_t>(inputX);
			//	y = static_cast<int32_t>(inputY);

			//}

			int32_t getX() const;

			void setX(int32_t inputX);

			int32_t getY() const;

			void setY(int32_t inputY);


			Point & operator += (Point const & pt_r);

			const Point operator + (Point const & pt_r) const;

			Point & operator -= (Point const & pt_r);

			const Point operator - (Point const & pt_r) const;

			virtual String toString() const;
		};
	
   

}

 //namespace podo

#endif
//POINT_H

