#ifndef PODO_STRING_H_
#define PODO_STRING_H_
#include "String.p"

#include "../system/SystemApi.h"
#include "Debug.h"






namespace podo{

		
	
	

		inline	WString const toWString(String const & str)  {

		#if defined(_PODO_WIN32)



			
			wchar_t * wstr  = new wchar_t [str.size() + 1];

			int nCount = ::MultiByteToWideChar(CP_ACP, MB_PRECOMPOSED,
				str.c_str(),static_cast<int>(str.size()) ,
				wstr,static_cast<int>(str.size() ));
			wstr[nCount] = '\0';

			WString result (wstr);
			delete [] wstr;

			return result;




		#elif defined(_PODO_POSIX)

			assertExp(false);

			return WString();

		#endif //



		}

		inline String toString(WString const &wstr ) {

			#if defined(_PODO_WIN32)
			
				char * str  = new char [ (wstr.size() * 2) + 1 ];

				int nCount = ::WideCharToMultiByte (CP_ACP, 0,
					wstr.c_str(),static_cast<int>(wstr.size()) ,
					str,static_cast<int>(wstr.size() * 2 ),NULL,NULL);
				str[nCount] = '\0';
				String result (str);
				delete [] str;

				return result;			

			#elif defined(_PODO_POSIX)

				assertExp(false);

				return String();

			#endif //

        
		}



		
		template <typename ResultString >
		inline ResultString toCarriage (ResultString const & str ) {

			ResultString result;

			typename ResultString::const_iterator const iterEnd = str.end();
			for(typename ResultString::const_iterator iter = str.begin()  ; iter != iterEnd ; ++iter) {
				if((*iter == '\n') 	&& ( *(iter - 1 ) != '\r')) {
					result += '\r';
				}else {
					//none;
				}

				result += *iter;				
			}

			return result;

		}


		inline WString const toCariageWString(WString const & str){
			return toCarriage<WString>(str);
		}

		inline String const toCariageString(String const & str){
			return toCarriage<String>(str);
		}


		template<typename ResultString>
		inline ResultString const toNonCarriage(ResultString const & str){

			ResultString result;

			typename ResultString::const_iterator const iterEnd = str.end();
			for(typename ResultString::const_iterator iter = str.begin()  ; iter != iterEnd ; ++iter) {
				if(*iter != '\r') {
					result += *iter;
				}else { //if '\r'
					//none
				}
			}

			return result;
		}

		inline WString const toNonCarriageWString(WString const & str){
			return toNonCarriage<WString>(str);			
		}

		inline String const toNonCarriageString(String const & str){
			return toNonCarriage<String>(str);	
		}
		
		
	

   

}

#endif
//PODO_STRING_H_

