
#ifndef UINT8_H_
#define UINT8_H_

#include "Debug.h"
#include <iostream>

namespace podo{
	 
		class UInt8 {
		private:
			unsigned char ch;
			static unsigned int const MIN_BOUND = 0;
			static unsigned int const MAX_BOUND = 255;

		public:
			UInt8() {
				ch = 0;

			}

			explicit UInt8(unsigned char initCh) {
				ch = initCh;
			}

			explicit UInt8(unsigned int initCh) {
			
				assertExp(MIN_BOUND <= initCh && initCh <= MAX_BOUND);
				ch = static_cast < unsigned char > (initCh);
			}

			explicit UInt8(int initCh) {
				assertExp(MIN_BOUND <= initCh && initCh <= MAX_BOUND);
				ch = static_cast < unsigned char > (initCh);
			}

			friend std::ostream & operator << (std::ostream & os, UInt8 const & in) {

				os << static_cast < unsigned int const > (in.ch);
				return os;
			}

			friend UInt8 operator + (UInt8 const & left, UInt8 const & right) {

				UInt8 temp(left.ch);
				temp += right;

				return temp;
			}

			int const toInt() const {
				return ch;
			}

			UInt8 & operator += (UInt8 const & right) {

				unsigned int tempLeft = ch;
				unsigned int tempRight = right.ch;

				unsigned int result = tempLeft + tempRight;
				assertExp(MIN_BOUND <= result && result <= MAX_BOUND);


				ch = static_cast < unsigned char > (result);

				return * this;
			}

			friend UInt8 operator - (UInt8 const & left, UInt8 const & right) {

				UInt8 temp(left.ch);
				temp -= right;

				return temp;
			}

			UInt8 & operator -= (UInt8 const & right) {

				unsigned int tempLeft = ch;
				unsigned int tempRight = right.ch;

				unsigned int result = tempLeft - tempRight;
				assertExp(MIN_BOUND <= result && result <= MAX_BOUND);


				ch = static_cast < unsigned char > (result);

				return * this;
			}


			friend bool const operator == (UInt8 const & left, UInt8 const & right) {

				return left.ch == right.ch;
			}

			friend bool const operator != (UInt8 const & left, UInt8 const & right) {

				return left.ch != right.ch;
			}



		};
	

}
#endif
//UINT8_H_

