/* Generated by Together */

#include "ApplicationInSystem.h"
#include "MessageQueue.h"
#include "Message.h"
#include "win32/InstanceHandle.h"

#include "../global/MouseButton.h"
#include "../global/KeyboardKey.h"
#include "../global/Debug.h"
#include "../global/Point.h"
#include "../global/Rect.h"
#include "PaintDrawStruct.h"
#include "ShortcutInvoker.h"






#ifdef _PODO_WIN32





bool const isIn(HWND hWnd,LPARAM lParam) {

	RECT rt;
	::GetClientRect(hWnd,&rt);

	podo::Rect rect(podo::Point(rt.left,rt.top ),podo:: Point(rt.right - 1,rt.bottom - 1 ) );

	podo::Point pt(LOWORD(lParam),HIWORD(lParam));

	return rect.isIn(pt);



}


LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam) {


    
	static HWND trackedHwnd = NULL;

	using namespace podo;
	MessageReceiver & receiver = ApplicationInSystem::instance().accessReceiver(hWnd);
	
	Message mess ;
	mess.hwnd = hWnd;
	mess.message = message;
	mess.wParam = wParam;
	mess.lParam = lParam;
	

	switch (message) {

	
	// case WM_MOUSEHOVER:
	//     assertExp(message.hwnd == trackedHwnd);
	//     goto distributeMessage
	//     break;
		case WM_MOUSELEAVE:
			//assertExp(hWnd == trackedHwnd);
			trackedHwnd = NULL;
			if(MessageReceiver::Processed == receiver.distributeMouseExitedMessage ()){
				return 0;
			}else {
				goto defaultProcess;
			}
			
	    
		case WM_MOUSEMOVE:
			if (trackedHwnd == NULL || hWnd != trackedHwnd) {

				TRACKMOUSEEVENT trackevent;
				trackevent.cbSize = sizeof(TRACKMOUSEEVENT);
				trackevent.dwFlags = //TME_HOVER |
									TME_LEAVE;
				trackevent.dwHoverTime = 0;
				trackevent.hwndTrack = hWnd;
				BOOL result = TrackMouseEvent(& trackevent);
				assertExp(result == TRUE);
				trackedHwnd = hWnd;

				if(MessageReceiver::Processed == receiver.distributeMouseEnteredMessage()){
					return 0;
				}else {
					goto defaultProcess;
				}
			}
			else {
			

				if(MessageReceiver::Processed == 
					receiver.distributeMouseMoveMessage (Point (LOWORD(lParam), HIWORD(lParam) ),isIn(hWnd,lParam))){
					return 0;
				}else {
					goto defaultProcess;
				}
			}
	
		     
			

		case WM_PAINT:{
		
			
			PaintDrawStruct paintDrawStruct(hWnd) ;


			if(MessageReceiver::Processed == receiver.distributePaintMessage(paintDrawStruct )){
				return 0;
			}else {
				goto defaultProcess;
			}

		}

			
			
		case WM_CLOSE:
			receiver.distributeCloseMessage();
			return 0;
		case WM_SIZE:{

				Size newSize(LOWORD(lParam), HIWORD(lParam));
				SizeEventSizeChanged event(newSize);

				receiver.invokeSizeListener(event);				
				return 0;
				
			}
			
        case WM_LBUTTONDOWN:     				
			if(MessageReceiver::Processed == 
				receiver.distributeMouseButtonMessage(true,MouseButton::LEFT,Point(LOWORD(lParam),	HIWORD(lParam)) ,isIn(hWnd,lParam) )){
				return 0;
			}else {
				goto defaultProcess;
			}
        case WM_LBUTTONUP:                
            if(MessageReceiver::Processed ==
				receiver.distributeMouseButtonMessage(false,MouseButton::LEFT,Point(LOWORD(lParam),HIWORD(lParam)),isIn(hWnd,lParam) )){
				return 0;
			}else {
				goto defaultProcess;
			}
        case WM_RBUTTONDOWN:
            if(MessageReceiver::Processed == 
				receiver.distributeMouseButtonMessage(true,MouseButton::RIGHT,Point(LOWORD(lParam),HIWORD(lParam)) ,isIn(hWnd,lParam) )){
				return 0;
			}else {
				goto defaultProcess;
			}
        case WM_RBUTTONUP:
            if(MessageReceiver::Processed == 
				receiver.distributeMouseButtonMessage(false,MouseButton::RIGHT,Point(LOWORD(lParam),HIWORD(lParam)),isIn(hWnd,lParam)  )){
				return 0;
			}else {
				goto defaultProcess;
			}
        case WM_MBUTTONDOWN:
            if(MessageReceiver::Processed == 
				receiver.distributeMouseButtonMessage(true,MouseButton::MIDDLE,Point(LOWORD(lParam),HIWORD(lParam)) ,isIn(hWnd,lParam) )){
				return 0;
			}else {
				goto defaultProcess;
			}
        case WM_MBUTTONUP:  
            if(MessageReceiver::Processed == 
				receiver.distributeMouseButtonMessage(false,MouseButton::MIDDLE,Point(LOWORD(lParam),HIWORD(lParam)), isIn(hWnd,lParam) )){
				return 0;
			}else {
				goto defaultProcess;
			}
        case WM_KEYDOWN:
			if(MessageReceiver::Processed ==
				receiver.distributeKeyMessage(true,getKey(mess) )){
				return 0;
			}else {
				goto defaultProcess;
			}
        case WM_KEYUP:
            if(MessageReceiver::Processed == 
				receiver.distributeKeyMessage(false,getKey(mess))){
				return 0;
			}else {
				goto defaultProcess;
			}

		case	DESTROY_REQUEST_MESSAGE:

            trackedHwnd = NULL;
			//ؿ ޼     ȴٰ  ִ..
			receiver.distributeEnforceDestroyMessage();
			return 0;
			
			
		case WM_SETFOCUS:{
			FocusEventFocusGained event;
			receiver.invokeFocusListener(event);
			}			
			return 0;            
		case WM_KILLFOCUS:{
			FocusEventFocusLost event;
			receiver.invokeFocusListener(event);
			}			
			return 0;
		default:
			goto defaultProcess;
				
		}


defaultProcess:


	return ::DefWindowProc(hWnd,message,wParam,lParam); 


	
}






int APIENTRY WinMain(HINSTANCE hInstance, HINSTANCE /*hPrevInstance*/, LPTSTR /*lpCmdLine*/, int /*nCmdShow*/) {



	podo::setInstanceHandle(hInstance);


    WNDCLASSEX wcex;

    wcex.cbSize = sizeof(WNDCLASSEX);

    wcex.style = 0;
    wcex.lpfnWndProc = (WNDPROC)WndProc;
    wcex.cbClsExtra = 0;
    wcex.cbWndExtra = 0;
    wcex.hInstance = hInstance;
    wcex.hIcon = NULL;
    wcex.hCursor = LoadCursor(NULL, IDC_ARROW);
    wcex.hbrBackground = NULL;
    wcex.lpszMenuName = NULL;
    wcex.lpszClassName = "KFC_COMPONENT";
    wcex.hIconSm = NULL;

    ATOM res = RegisterClassEx(& wcex);

    if (res == 0) {
        //DWORD aaa = ::GetLastError();
        //reportBug(aaa);
		using namespace podo;
        assertExp(false);

    }



	int result = podo::main();

	podo::removeInstanceHandle();



    return result;


}


#elif defined(_PODO_POSIX)

//f   Ѥ 츮    

#include <stdio.h>
#include <stdlib.h>		/* getenv(), etc. */
#include <unistd.h>		/* sleep(), etc.  */






int ::main(int argc, char * * argv) {


	



    int result = podo::main();
    // Լ ȣ



	podo::removeGlobalHandle();

    return result;


}

#endif



namespace podo{



	bool ApplicationInSystem::invokeShortcutMessage(Message & message) {
		if(!isKeyDownMessage(message)) {
			return false;
		}


		KeyboardKey key = getKey(message);
		if(ShortcutInvoker::Processed == ShortcutInvoker::instance().distributeMessage(key)) {

			return true;
		}
		else {
			return false;
		}
	}


	void ApplicationInSystem::dispatchMessage(Message & message){



#if defined(_PODO_WIN32)

		//WndProc å ѱ..
		::DispatchMessage(&message);

#elif defined(_PODO_POSIX)

		MessageReceiver & receiver = accessReceiver(accessWindowID(message));

		switch (message.type) {


		case ClientMessage:{

				if ((Atom) message.xclient.data.l[0] ==  AtomMaps::instance().getAtom("WM_DELETE_WINDOW") ){

						receiver.distributeCloseMessage();
				}
				return;
			}

		case Expose:{
				if(message.xexpose.count > 0) {
					return;
				}

				if(&receiver == &NullMessageReceiver::instance()){
					return;
				}

				PaintDrawStruct drawStruct( message.xexpose.window,Size(1280,1024) );

				receiver.distributePaintMessage( drawStruct);

				return;
			}


		case ButtonPress:{

				Point point =Point(message.xbutton.x,message.xbutton.y);
				switch(message.xbutton.button){
					case Button1:
						receiver.distributeMouseButtonMessage(true, podo::MouseButton::LEFT,point ,true);
						return;

					case Button2:
						receiver.distributeMouseButtonMessage(true, podo::MouseButton::MIDDLE,point ,true);
						return;
					case Button3:
						receiver.distributeMouseButtonMessage(true, podo::MouseButton::RIGHT,point ,true);
						return;
					default:                        
						return;
				}


				return;

			}
		    


		case ButtonRelease: {

				Point point =Point(message.xbutton.x,message.xbutton.y);
				switch(message.xbutton.button){
					case Button1:
						receiver.distributeMouseButtonMessage(false, MouseButton::LEFT,point,true );
						return;

					case Button2:
						receiver.distributeMouseButtonMessage(false, MouseButton::MIDDLE ,point,true);
						return;
					case Button3:
						receiver.distributeMouseButtonMessage(false,  MouseButton::RIGHT,point,true);
						return;
					default:
						return;
				}

			}

		case ConfigureNotify:{

				
				Size newSize(message.xconfigurerequest.width, message.xconfigurerequest.height);						
				SizeEventSizeChanged event(newSize);

				receiver.invokeSizeListener(event);

				return;
			}
		case KeyPress:{

				KeyboardKey key = getKey(message);
				receiver.distributeKeyMessage(true, key);
				return;
			}
		case KeyRelease:{
				KeyboardKey key = getKey(message);
				receiver.distributeKeyMessage(false, key);
				return;
			}
		case MotionNotify:{
				//trace("move");
				bool bIn = message.xmotion.same_screen;
				receiver.distributeMouseMoveMessage(Point(message.xmotion.x ,message.xmotion.y),bIn );
				return;
			}
		case EnterNotify:

			trace("enter");

			receiver.distributeMouseEnteredMessage();
			return;

		case LeaveNotify:
			
			receiver.distributeMouseExitedMessage();
			return;


		case DestroyNotify:	
			return;

		case FocusIn:

			{
				FocusEventFocusGained event;
				receiver.invokeFocusListener(event);
			}			

            return;
		case FocusOut:{
				FocusEventFocusLost event;
				receiver.invokeFocusListener(event);
			}			

			return;
		case	DESTROY_REQUEST_MESSAGE:
			trace("real end");	
			receiver.distributeEnforceDestroyMessage();
			return ;

		default:
			return ;
		}//endswitch

#endif

	}//end Func



}//end Namespace


