/* Generated by Together */

#ifndef APPLICATIONINSYSTEM_H
#define APPLICATIONINSYSTEM_H



#include "Message.h"
#include "posix/GlobalHandle.h"
#include "MessageReceiver.h"



#include "../global/DummyPointerContainer.h"
#include "../global/Debug.h"

//#include "global/AggregationAttribute.h"

#include <vector>
#include <map>
#include <string>





	#if defined(_PODO_WIN32)
		//none

	#elif defined(_PODO_POSIX)

	#include <string>
	#include <map>

		typedef struct {
			unsigned long flags;
			unsigned long functions;
			unsigned long decorations;
			long input_mode;
			unsigned long status;
		} MotifWmHints, MwmHints;



#define MWM_HINTS_FUNCTIONS     (1L << 0)
#define MWM_HINTS_DECORATIONS   (1L << 1)
#define MWM_HINTS_INPUT_MODE    (1L << 2)
#define MWM_HINTS_STATUS        (1L << 3)

#define MWM_FUNC_ALL            (1L << 0)
#define MWM_FUNC_RESIZE         (1L << 1)
#define MWM_FUNC_MOVE           (1L << 2)
#define MWM_FUNC_MINIMIZE       (1L << 3)
#define MWM_FUNC_MAXIMIZE       (1L << 4)
#define MWM_FUNC_CLOSE          (1L << 5)

#define MWM_DECOR_ALL           (1L << 0)
#define MWM_DECOR_BORDER        (1L << 1)
#define MWM_DECOR_RESIZEH       (1L << 2)
#define MWM_DECOR_TITLE         (1L << 3)
#define MWM_DECOR_MENU          (1L << 4)
#define MWM_DECOR_MINIMIZE      (1L << 5)
#define MWM_DECOR_MAXIMIZE      (1L << 6)

#define MWM_INPUT_MODELESS 0
#define MWM_INPUT_PRIMARY_APPLICATION_MODAL 1
#define MWM_INPUT_SYSTEM_MODAL 2
#define MWM_INPUT_FULL_APPLICATION_MODAL 3
#define MWM_INPUT_APPLICATION_MODAL MWM_INPUT_PRIMARY_APPLICATION_MODAL


		class AtomMaps {
			std::map<std::string,Atom> _data;

			public:
			static AtomMaps& instance() {
				static AtomMaps instance;
				return instance;
			}

			Atom getAtom(std::string str) {
				if(_data.find(str) == _data.end()) {
					Atom temp = XInternAtom(podo::getGlobalHandle(),str.c_str() ,False);

					assertExp(temp != 0);
					if(temp == 0){
						trace('\n'<<str<<" : "<<temp);
					}
					_data.insert(std::pair<std::string,Atom>(str,temp));

				}

				return _data[str];
			}

			Atom getAtom(char const * str) {
				return getAtom(std::string(str));
			}

		};
	#endif







namespace podo{





	class ApplicationInSystem {
	public:

		static ApplicationInSystem & instance(){
			static ApplicationInSystem instance;
			return instance;
		}

	private:



	public:

		
		void dispatchMessage(Message & message) ;

		//  true ƴϸ false;
		bool invokeShortcutMessage(Message & message);

	private:	
		std::map<WindowID ,MessageReceiver*> _receivers;

		

	public:

		MessageReceiver & accessReceiver(WindowID id ){
			if(_receivers.find(id) != _receivers.end()) {
				return * _receivers[id];
			}else {
				return NullMessageReceiver::instance();
				//return receiver;
			}

		}

		void registReceiver(WindowID id, MessageReceiver & receiver) {
			_receivers.insert(std::pair<WindowID,MessageReceiver*>  (id,&receiver));
		}

		void unregistReceiver(WindowID id) {
			_receivers.erase(id);
		}




	};


	extern int main() ;

}
#endif
 //APPLICATIONINSYSTEM_H
 
