/* Generated by Together */

#ifndef BITMAPDRAWSTRUCT_H
#define BITMAPDRAWSTRUCT_H

#include "InOutDrawStruct.h"
#include "InOutDrawStructDefault.h"
#include "../global/Brush.h"
#include "../global/Pen.h"
#include "../global/Font.h"
#include "posix/GlobalHandle.h"



#include "BitmapImpl.h"


namespace podo{

		class BitmapDrawStruct : public InOutDrawStruct {




		private:
		

			Brush _brush;
			Pen _pen;
			Font _font;

			InOutDrawStructDefault::DrawableHandle  _drawableHandle;
			
#if defined(_PODO_WIN32)
			BitmapImpl::BitmapHandle _oldBitmapHandle;			
#elif defined(_PODO_POSIX)
			BitmapImpl::BitmapHandle _bitmapHandle;		
#endif




		public:
			//.
			BitmapDrawStruct(BitmapImpl::BitmapHandle bitmapHandle,Size const size):
				InOutDrawStruct(Rect(Point(),size),Point()) {

#if defined(_PODO_WIN32)
				HDC _drawableHandle = ::CreateCompatibleDC(NULL)	;
				_oldBitmapHandle = (HBITMAP)::SelectObject(_drawableHandle,bitmapHandle);

#elif defined(_PODO_POSIX)
				_drawableHandle.drawable = bitmapHandle;
				_drawableHandle.gc = XCreateGC(getGlobalHandle(),bitmapHandle,0,NULL );


#endif
			}

			~BitmapDrawStruct() {

#if defined(_PODO_WIN32)

				::SelectObject(_drawableHandle,_oldBitmapHandle);
                ::DeleteDC(_drawableHandle);

#elif defined(_PODO_POSIX)

				XFreeGC(getGlobalHandle(),_drawableHandle.gc);


#endif
			}



			


		public:      




			virtual void setPen(Pen const &pen) ;
			virtual void setBrush(Brush const & brush);
			virtual void setFont(Font const & font) ;

			virtual void fillRect(Rect const & rt) ;
			virtual void lineLine(Point const & from, Point const & to) ;
			/*virtual void write(WString const &text, Rect const & releateRect,
				Font::VerticalWriteMode verticalMode ,
				Font::HorizontalWriteMode horizontalMode 	)  ;		*/

			virtual void write	(WString const &text, Point const & point,
				Font::VerticalWriteMode verticalMode,
				Font::HorizontalWriteMode horizontalMode  ) ;	

			virtual void init(Pen const &pen, Brush const &brush);
			virtual void exit() ;
		};

		
}
#endif //BITMAPDRAWSTRUCT_H
