

#include "BitmapImpl.h"
#include "../global/Debug.h"
#include "BitmapDrawStruct.h"



namespace podo{




		
		BitmapImpl::BitmapImpl(Size const & size):_size(size) {		      		
		
		#if defined(_PODO_WIN32)
		
		
		
		        ::HDC dc =::GetDC(NULL);
		        handle =::CreateCompatibleBitmap(dc, _size.getWidth (),_size.getHeight() );
		        if (handle == NULL) {
		
		          //  assertExp(false);
		
		            ::abort();
		
		        }
		        ::ReleaseDC(NULL, dc);
		#elif defined(_PODO_POSIX)		
		        Window id = XDefaultRootWindow(getGlobalHandle());
		        int depth = XDefaultDepth(getGlobalHandle(), 0);
		        handle = XCreatePixmap(getGlobalHandle(), id, size.getWidth(), size.getHeight() ,depth);
		
		#endif

		}

		InOutDrawStruct *BitmapImpl::createDrawStruct() {
			
			InOutDrawStruct * graphics = new BitmapDrawStruct(handle,_size);
			return graphics;
		}

	

	

		BitmapImpl::~BitmapImpl() {
			
			#if defined(_PODO_WIN32)
					::DeleteObject(handle);
			#elif defined(_PODO_POSIX)
					XFreePixmap(getGlobalHandle(), handle);
			#endif

		}

}
