#ifndef _BITMAPIMPL_H
#define _BITMAPIMPL_H


#include "SystemApi.h"
#include "../global/Size.h"

#include "InOutDrawStruct.p"





namespace podo{

		class BitmapImpl {
		public:
	#if defined(_PODO_WIN32)
			typedef ::HBITMAP  BitmapHandle;
	#elif defined(_PODO_POSIX)
			typedef ::Pixmap BitmapHandle;
	#endif


		private:
			BitmapHandle handle;

			Size _size;
	public:

			Size const &getSize() const {
				return _size;
			}

            /**
             * @directed
             * @label create 
             */
            
			InOutDrawStruct *createDrawStruct();
	

			BitmapImpl(uint32_t width = 1000, uint32_t height = 1000);
			BitmapImpl(Size const & size);

			~BitmapImpl();
			



		};

}



#endif

///BITMAPIMPL_H
