/* Generated by Together */

#include "Message.h"
#include "../global/KeyboardKey.h"
#include "../global/Debug.h"
#include "posix/GlobalHandle.h"




#if defined (_PODO_WIN32)

#elif defined(_PODO_POSIX)


	#define XK_LATIN1
	#include <X11/keysymdef.h>



#endif

namespace podo{
	

		void dispatch(Message & message){
            


		}

		WindowID accessWindowID(Message & message) {
#if defined(_PODO_WIN32)
			return message.hwnd;
#elif defined(_PODO_POSIX)
		switch(message.type) {
				case CreateNotify:
				return message.xcreatewindow.window;

				case DestroyNotify:
				return message.xdestroywindow.window;
	
				case UnmapNotify:
				return message.xunmap.window;
	
				case MapNotify:
				return message.xmap.window;
	
				case MapRequest:
				return message.xmaprequest.window;
	
				case ReparentNotify:
				return message.xreparent.window;
					
				case ConfigureNotify:
				return message.xconfigure.window;
					
				case ConfigureRequest:
				return message.xconfigurerequest.window;
	
				case GravityNotify:
				return message.xgravity.window;
	
				case CirculateNotify:
				return message.xcirculate.window;
	
				case CirculateRequest:
				return message.xcirculaterequest.window;
				
				case ClientMessage:
				return message.xclient.window;
				
			//	case DestroyNotify: 
			//	return message.xdestroywindow.window;
				
			//	case UnmapNotify: 
			//	return message.xunmap.window;
	
				default:
				return message.xany.window;
			}
#endif
		}

		MessageType const& getMessageType(Message & message) {
#if defined(_PODO_WIN32)
			return message .message;
#elif defined(_PODO_POSIX)
			return message.type;
#endif

		}




		 KeyboardKey getKey(Message const & message) {

			// assertExp(isKeyDownMessage(message ));
        
        
        #if defined(_PODO_WIN32)
        
            KeyboardKey::Virtualkey vk;
        
            switch (message.wParam) {
                case 0x30:
                    vk = KeyboardKey::VIRTUAL_0;
                    break;
                case 0x31:
                    vk = KeyboardKey::VIRTUAL_1;
                    break;
                case 0x32:
                    vk = KeyboardKey::VIRTUAL_2;
                    break;
                case 0x33:
                    vk = KeyboardKey::VIRTUAL_3;
                    break;
                case 0x34:
                    vk = KeyboardKey::VIRTUAL_4;
                    break;
                case 0x35:
                    vk = KeyboardKey::VIRTUAL_5;
                    break;
                case 0x36:
                    vk = KeyboardKey::VIRTUAL_6;
                    break;
                case 0x37:
                    vk = KeyboardKey::VIRTUAL_7;
                    break;
                case 0x38:
                    vk = KeyboardKey::VIRTUAL_8;
                    break;
                case 0x39:
                    vk = KeyboardKey::VIRTUAL_9;
                    break;
                case 0x41:
                    vk = KeyboardKey::VIRTUAL_A;
                    break;
                case 0x42:
                    vk = KeyboardKey::VIRTUAL_B;
                    break;
                case 0x43:
                    vk = KeyboardKey::VIRTUAL_C;
                    break;
                case 0x44:
                    vk = KeyboardKey::VIRTUAL_D;
                    break;
                case 0x45:
                    vk = KeyboardKey::VIRTUAL_E;
                    break;
                case 0x46:
                    vk = KeyboardKey::VIRTUAL_F;
                    break;
                case 0x47:
                    vk = KeyboardKey::VIRTUAL_G;
                    break;
                case 0x48:
                    vk = KeyboardKey::VIRTUAL_H;
                    break;
                case 0x49:
                    vk = KeyboardKey::VIRTUAL_I;
                    break;
                case 0x4A:
                    vk = KeyboardKey::VIRTUAL_J;
                    break;
                case 0x4B:
                    vk = KeyboardKey::VIRTUAL_K;
                    break;
                case 0x4C:
                    vk = KeyboardKey::VIRTUAL_L;
                    break;
                case 0x4D:
                    vk = KeyboardKey::VIRTUAL_M;
                    break;
                case 0x4E:
                    vk = KeyboardKey::VIRTUAL_N;
                    break;
                case 0x4F:
                    vk = KeyboardKey::VIRTUAL_O;
                    break;
                case 0x50:
                    vk = KeyboardKey::VIRTUAL_P;
                    break;
                case 0x51:
                    vk = KeyboardKey::VIRTUAL_Q;
                    break;
                case 0x52:
                    vk = KeyboardKey::VIRTUAL_R;
                    break;
                case 0x53:
                    vk = KeyboardKey::VIRTUAL_S;
                    break;
                case 0x54:
                    vk = KeyboardKey::VIRTUAL_T;
                    break;
                case 0x55:
                    vk = KeyboardKey::VIRTUAL_U;
                    break;
                case 0x56:
                    vk = KeyboardKey::VIRTUAL_V;
                    break;
                case 0x57:
                    vk = KeyboardKey::VIRTUAL_W;
                    break;
                case 0x58:
                    vk = KeyboardKey::VIRTUAL_X;
                    break;
                case 0x59:
                    vk = KeyboardKey::VIRTUAL_Y;
                    break;
                case 0x5A:
                    vk = KeyboardKey::VIRTUAL_Z;
                    break;
				case VK_BACK:
					vk = KeyboardKey::VIRTUAL_BACKSPACE ;
					break;
				case VK_SHIFT:
					vk = KeyboardKey::VIRTUAL_SHIFT ;
					break;
				case VK_CONTROL:
					vk = KeyboardKey::VIRTUAL_CONTROL;
					break;

				case VK_RETURN:
					vk = KeyboardKey::VIRTUAL_RETURN;
					break;

				case VK_SPACE:
					vk = KeyboardKey::VIRTUAL_SPACE;
					break;

				case VK_DELETE:
					vk = KeyboardKey::VIRTUAL_DEL ;
					break;

						
				case 	VK_PRIOR ://(21)	PAGE UP key                    
					vk = KeyboardKey::VIRTUAL_PAGEUP ;
					break;

				case 	VK_NEXT : //(22)	PAGE DOWN key
					vk = KeyboardKey::VIRTUAL_PAGEDOWN;
					break;

				case 	VK_END: //(23)		END key
					vk = KeyboardKey::VIRTUAL_END ;
					break;

				case 	VK_HOME: //(24)		HOME key
					vk = KeyboardKey::VIRTUAL_HOME ;
					break;

				case 	VK_LEFT: //(25)		LEFT ARROW key
					vk = KeyboardKey::VIRTUAL_LEFT ;
					break;

				case 	VK_UP ://(26)		UP ARROW key
					vk = KeyboardKey::VIRTUAL_UP ;
					break;

				case 	VK_RIGHT: //(27)	RIGHT ARROW key
					vk = KeyboardKey::VIRTUAL_RIGHT ;
					break;

				case 	VK_DOWN ://(28)		DOWN ARROW key
					vk = KeyboardKey::VIRTUAL_DOWN ;
					break;

				case VK_TAB:
					vk = KeyboardKey::VIRTUAL_TAB;
					break;

				case VK_ESCAPE:
					vk = KeyboardKey::VIRTUAL_ESCAPE;
					break;

                default:
                    vk = KeyboardKey::VIRTUAL_NULL;
                    break;
            }


			bool shift = ::GetKeyState(VK_SHIFT)  < 0 ;
			bool control =  (GetKeyState(  VK_CONTROL) < 0)  ;
			bool alt = ::GetKeyState(VK_MENU) < 0;

			return KeyboardKey(vk, shift, control, alt);

/*	VK_LBUTTON (01)
Left mouse button

VK_RBUTTON (02)
Right mouse button

VK_CANCEL (03)
Control-break processing

VK_MBUTTON (04)
Middle mouse button (three-button mouse)

VK_XBUTTON1 (05)
Windows 2000/XP: X1 mouse button

VK_XBUTTON2 (06)
Windows 2000/XP: X2 mouse button

- (07)
Undefined


VK_TAB (09)
TAB key

- (0A-0B)
Reserved

VK_CLEAR (0C)
CLEAR key

VK_RETURN (0D)
ENTER key



VK_MENU (12)
ALT key

VK_PAUSE (13)
PAUSE key

VK_CAPITAL (14)
CAPS LOCK key

VK_KANA (15)
Input Method Editor (IME) Kana mode

VK_HANGUEL (15)
IME Hanguel mode (maintained for compatibility; use VK_HANGUL)

VK_HANGUL (15)
IME Hangul mode

- (16)
Undefined

VK_JUNJA (17)
IME Junja mode

VK_FINAL (18)
IME final mode

VK_HANJA (19)
IME Hanja mode

VK_KANJI (19)
IME Kanji mode

- (1A)
Undefined

VK_ESCAPE (1B)
ESC key

VK_CONVERT (1C)
IME convert

VK_NONCONVERT (1D)
IME nonconvert

VK_ACCEPT (1E)
IME accept

VK_MODECHANGE (1F)
IME mode change request



VK_SELECT (29)
SELECT key

VK_PRINT (2A)
PRINT key

VK_EXECUTE (2B)
EXECUTE key

VK_SNAPSHOT (2C)
PRINT SCREEN key

VK_INSERT (2D)
INS key

VK_DELETE (2E)
DEL key

VK_HELP (2F)
HELP key


VK_LWIN (5B)
Left Windows key (Microsoft? Natural? keyboard) 

VK_RWIN (5C)
Right Windows key (Natural keyboard)

VK_APPS (5D)
Applications key (Natural keyboard)

- (5E)
Reserved

VK_SLEEP (5F)
Computer Sleep key

VK_NUMPAD0 (60)
Numeric keypad 0 key

VK_NUMPAD1 (61)
Numeric keypad 1 key

VK_NUMPAD2 (62)
Numeric keypad 2 key

VK_NUMPAD3 (63)
Numeric keypad 3 key

VK_NUMPAD4 (64)
Numeric keypad 4 key

VK_NUMPAD5 (65)
Numeric keypad 5 key

VK_NUMPAD6 (66)
Numeric keypad 6 key

VK_NUMPAD7 (67)
Numeric keypad 7 key

VK_NUMPAD8 (68)
Numeric keypad 8 key

VK_NUMPAD9 (69)
Numeric keypad 9 key

VK_MULTIPLY (6A)
Multiply key

VK_ADD (6B)
Add key

VK_SEPARATOR (6C)
Separator key

VK_SUBTRACT (6D)
Subtract key

VK_DECIMAL (6E)
Decimal key

VK_DIVIDE (6F)
Divide key

VK_F1 (70)
F1 key

VK_F2 (71)
F2 key

VK_F3 (72)
F3 key

VK_F4 (73)
F4 key

VK_F5 (74)
F5 key

VK_F6 (75)
F6 key

VK_F7 (76)
F7 key

VK_F8 (77)
F8 key

VK_F9 (78)
F9 key

VK_F10 (79)
F10 key

VK_F11 (7A)
F11 key

VK_F12 (7B)
F12 key

VK_F13 (7C)
F13 key

VK_F14 (7D)
F14 key

VK_F15 (7E)
F15 key

VK_F16 (7F)
F16 key

VK_F17 (80H)
F17 key

VK_F18 (81H)
F18 key

VK_F19 (82H)
F19 key

VK_F20 (83H)
F20 key

VK_F21 (84H)
F21 key

VK_F22 (85H)
F22 key

VK_F23 (86H)
F23 key

VK_F24 (87H)
F24 key

- (88-8F)
Unassigned

VK_NUMLOCK (90)
NUM LOCK key

VK_SCROLL (91)
SCROLL LOCK key

 (92-96)
OEM specific

- (97-9F)
Unassigned

VK_LSHIFT (A0)
Left SHIFT key

VK_RSHIFT (A1)
Right SHIFT key

VK_LCONTROL (A2)
Left CONTROL key

VK_RCONTROL (A3)
Right CONTROL key

VK_LMENU (A4)
Left MENU key

VK_RMENU (A5)
Right MENU key

VK_BROWSER_BACK (A6)
Windows 2000/XP: Browser Back key

VK_BROWSER_FORWARD (A7)
Windows 2000/XP: Browser Forward key

VK_BROWSER_REFRESH (A8)
Windows 2000/XP: Browser Refresh key

VK_BROWSER_STOP (A9)
Windows 2000/XP: Browser Stop key

VK_BROWSER_SEARCH (AA)
Windows 2000/XP: Browser Search key 

VK_BROWSER_FAVORITES (AB)
Windows 2000/XP: Browser Favorites key

VK_BROWSER_HOME (AC)
Windows 2000/XP: Browser Start and Home key

VK_VOLUME_MUTE (AD)
Windows 2000/XP: Volume Mute key

VK_VOLUME_DOWN (AE)
Windows 2000/XP: Volume Down key

VK_VOLUME_UP (AF)
Windows 2000/XP: Volume Up key

VK_MEDIA_NEXT_TRACK (B0)
Windows 2000/XP: Next Track key

VK_MEDIA_PREV_TRACK (B1)
Windows 2000/XP: Previous Track key

VK_MEDIA_STOP (B2)
Windows 2000/XP: Stop Media key

VK_MEDIA_PLAY_PAUSE (B3)
Windows 2000/XP: Play/Pause Media key

VK_LAUNCH_MAIL (B4)
Windows 2000/XP: Start Mail key

VK_LAUNCH_MEDIA_SELECT (B5)
Windows 2000/XP: Select Media key

VK_LAUNCH_APP1 (B6)
Windows 2000/XP: Start Application 1 key

VK_LAUNCH_APP2 (B7)
Windows 2000/XP: Start Application 2 key

- (B8-B9)
Reserved

VK_OEM_1 (BA)
Used for miscellaneous characters; it can vary by keyboard.
Windows 2000/XP: For the US standard keyboard, the ';:' key 


VK_OEM_PLUS (BB)
Windows 2000/XP: For any country/region, the '+' key

VK_OEM_COMMA (BC)
Windows 2000/XP: For any country/region, the ',' key

VK_OEM_MINUS (BD)
Windows 2000/XP: For any country/region, the '-' key

VK_OEM_PERIOD (BE)
Windows 2000/XP: For any country/region, the '.' key

VK_OEM_2 (BF)
Used for miscellaneous characters; it can vary by keyboard.
Windows 2000/XP: For the US standard keyboard, the '/?' key 


VK_OEM_3 (C0)
Used for miscellaneous characters; it can vary by keyboard. 
Windows 2000/XP: For the US standard keyboard, the '`~' key 


- (C1-D7)
Reserved

- (D8-DA)
Unassigned

VK_OEM_4 (DB)
Used for miscellaneous characters; it can vary by keyboard. 
Windows 2000/XP: For the US standard keyboard, the '[{' key


VK_OEM_5 (DC)
Used for miscellaneous characters; it can vary by keyboard. 
Windows 2000/XP: For the US standard keyboard, the '\|' key


VK_OEM_6 (DD)
Used for miscellaneous characters; it can vary by keyboard.
Windows 2000/XP: For the US standard keyboard, the ']}' key


VK_OEM_7 (DE)
Used for miscellaneous characters; it can vary by keyboard. 
Windows 2000/XP: For the US standard keyboard, the 'single-quote/double-quote' key


VK_OEM_8 (DF)
Used for miscellaneous characters; it can vary by keyboard.

- (E0)
Reserved

 (E1)
OEM specific

VK_OEM_102 (E2)
Windows 2000/XP: Either the angle bracket key or the backslash key on the RT 102-key keyboard

 (E3-E4)
OEM specific

VK_PROCESSKEY (E5)
Windows 95/98/Me, Windows NT 4.0, Windows 2000/XP: IME PROCESS key

 (E6)
OEM specific

VK_PACKET (E7)
Windows 2000/XP: Used to pass Unicode characters as if they were keystrokes. The VK_PACKET key is the low word of a 32-bit Virtual Key value used for non-keyboard input methods. For more information, see Remark in KEYBDINPUT, SendInput, WM_KEYDOWN, and WM_KEYUP

- (E8)
Unassigned

 (E9-F5)
OEM specific

VK_ATTN (F6)
Attn key

VK_CRSEL (F7)
CrSel key

VK_EXSEL (F8)
ExSel key

VK_EREOF (F9)
Erase EOF key

VK_PLAY (FA)
Play key

VK_ZOOM (FB)
Zoom key

VK_NONAME (FC)
Reserved for future use

VK_PA1 (FD)
PA1 key

VK_OEM_CLEAR (FE)
Clear key*/

            

        #elif defined(_PODO_POSIX)

            KeyboardKey::Virtualkey vk;


            KeySym key_symbol = XKeycodeToKeysym(getGlobalHandle(), message.xkey.keycode, 0);

            switch (key_symbol) {


				case  XK_0   :
					vk = KeyboardKey::VIRTUAL_0;
                    break;
				case  XK_1   :
					vk = KeyboardKey::VIRTUAL_1;
                    break;
				case  XK_2   :
					vk = KeyboardKey::VIRTUAL_2;
                    break;
				case  XK_3   :
					vk = KeyboardKey::VIRTUAL_3;
                    break;
				case  XK_4   :
					vk = KeyboardKey::VIRTUAL_4;
                    break;
				case  XK_5   :
					vk = KeyboardKey::VIRTUAL_5;
                    break;
				case  XK_6   :
					vk = KeyboardKey::VIRTUAL_6;
                    break;
				case  XK_7   :
					vk = KeyboardKey::VIRTUAL_7;
                    break;
				case  XK_8   :
					vk = KeyboardKey::VIRTUAL_8;
                    break;
				case  XK_9   :
					vk = KeyboardKey::VIRTUAL_9;
                    break;

                case XK_A:
				case XK_a:
					vk = KeyboardKey::VIRTUAL_A;
                    break;
				case XK_B:
				case XK_b:
					vk = KeyboardKey::VIRTUAL_B;
                    break;
				case XK_C:
				case XK_c:
					vk = KeyboardKey::VIRTUAL_C;
                    break;
				case XK_D:
				case XK_d:
					vk = KeyboardKey::VIRTUAL_D;
                    break;
				case XK_E:
				case XK_e:
					vk = KeyboardKey::VIRTUAL_E;
                    break;
				case XK_F:
				case XK_f:
					vk = KeyboardKey::VIRTUAL_F;
                    break;
				case XK_G:
				case XK_g:
					vk = KeyboardKey::VIRTUAL_G;
                    break;
				case XK_H:
				case XK_h:
					vk = KeyboardKey::VIRTUAL_H;
                    break;
				case XK_I:
				case XK_i:
					vk = KeyboardKey::VIRTUAL_I;
                    break;
				case XK_J:
				case XK_j:
					vk = KeyboardKey::VIRTUAL_J;
                    break;
				case XK_K:
				case XK_k:
					vk = KeyboardKey::VIRTUAL_K;
                    break;
				case XK_L:
				case XK_l:
					vk = KeyboardKey::VIRTUAL_L;
                    break;
				case XK_M:
				case XK_m:
					vk = KeyboardKey::VIRTUAL_M;
                    break;
				case XK_N:
				case XK_n:
					vk = KeyboardKey::VIRTUAL_N;
                    break;
				case XK_O:
				case XK_o:
					vk = KeyboardKey::VIRTUAL_O;
                    break;
				case XK_P:
				case XK_p:
					vk = KeyboardKey::VIRTUAL_P;
                    break;
				case XK_Q:
				case XK_q:
					vk = KeyboardKey::VIRTUAL_Q;
                    break;
				case XK_R:
				case XK_r:
					vk = KeyboardKey::VIRTUAL_R;
                    break;
				case XK_S:
				case XK_s:
					vk = KeyboardKey::VIRTUAL_S;
                    break;
				case XK_T:
				case XK_t:
					vk = KeyboardKey::VIRTUAL_T;
                    break;
				case XK_U:
				case XK_u:
					vk = KeyboardKey::VIRTUAL_U;
                    break;
				case XK_V:
				case XK_v:
					vk = KeyboardKey::VIRTUAL_V;
                    break;
				case XK_W:
				case XK_w:
					vk = KeyboardKey::VIRTUAL_W;
                    break;
				case XK_X:
				case XK_x:
					vk = KeyboardKey::VIRTUAL_X;
                    break;
				case XK_Y:
				case XK_y:
					vk = KeyboardKey::VIRTUAL_Y;
                    break;
				case XK_Z:
				case XK_z:
					vk = KeyboardKey::VIRTUAL_Z;
                    break;
				case XK_space :
					vk = KeyboardKey::VIRTUAL_SPACE;
					break;

				//case XK_

                default:
                    vk = KeyboardKey::VIRTUAL_NULL;
                    break;
            }
        


        
        
            bool shift = false;
            bool control = false;
            bool alt = false;

			//trace("key" << int(vk) );
        
			 return KeyboardKey(vk, shift, control, alt);
        #endif




        /*

        
        #ifdef XK_LATIN1
        #define XK_space               0x020
        #define XK_exclam              0x021
        #define XK_quotedbl            0x022
        #define XK_numbersign          0x023
        #define XK_dollar              0x024
        #define XK_percent             0x025
        #define XK_ampersand           0x026
        #define XK_apostrophe          0x027
        #define XK_quoteright          0x027
        #define XK_parenleft           0x028
        #define XK_parenright          0x029
        #define XK_asterisk            0x02a
        #define XK_plus                0x02b
        #define XK_comma               0x02c
        #define XK_minus               0x02d
        #define XK_period              0x02e
        #define XK_slash               0x02f
        
        #define XK_colon               0x03a
        #define XK_semicolon           0x03b
        #define XK_less                0x03c
        #define XK_equal               0x03d
        #define XK_greater             0x03e
        #define XK_question            0x03f
        #define XK_at                  0x040
        #define XK_A                   0x041
        #define XK_B                   0x042
        #define XK_C                   0x043
        #define XK_D                   0x044
        #define XK_E                   0x045
        #define XK_F                   0x046
        #define XK_G                   0x047
        #define XK_H                   0x048
        #define XK_I                   0x049
        #define XK_J                   0x04a
        #define XK_K                   0x04b
        #define XK_L                   0x04c
        #define XK_M                   0x04d
        #define XK_N                   0x04e
        #define XK_O                   0x04f
        #define XK_P                   0x050
        #define XK_Q                   0x051
        #define XK_R                   0x052
        #define XK_S                   0x053
        #define XK_T                   0x054
        #define XK_U                   0x055
        #define XK_V                   0x056
        #define XK_W                   0x057
        #define XK_X                   0x058
        #define XK_Y                   0x059
        #define XK_Z                   0x05a
        #define XK_bracketleft         0x05b
        #define XK_backslash           0x05c
        #define XK_bracketright        0x05d
        #define XK_asciicircum         0x05e
        #define XK_underscore          0x05f
        #define XK_grave               0x060
        #define XK_quoteleft           0x060
        #define XK_a                   0x061
        #define XK_b                   0x062
        #define XK_c                   0x063
        #define XK_d                   0x064
        #define XK_e                   0x065
        #define XK_f                   0x066
        #define XK_g                   0x067
        #define XK_h                   0x068
        #define XK_i                   0x069
        #define XK_j                   0x06a
        #define XK_k                   0x06b
        #define XK_l                   0x06c
        #define XK_m                   0x06d
        #define XK_n                   0x06e
        #define XK_o                   0x06f
        #define XK_p                   0x070
        #define XK_q                   0x071
        #define XK_r                   0x072
        #define XK_s                   0x073
        #define XK_t                   0x074
        #define XK_u                   0x075
        #define XK_v                   0x076
        #define XK_w                   0x077
        #define XK_x                   0x078
        #define XK_y                   0x079
        #define XK_z                   0x07a
        #define XK_braceleft           0x07b
        #define XK_bar                 0x07c
        #define XK_braceright          0x07d
        #define XK_asciitilde          0x07e
        
        
        
        */

        
           
			}
        
       
 }
   





