/* Generated by Together */

#ifndef SHORTCUTOWNER_H
#define SHORTCUTOWNER_H

#include "../global/Debug.h"


#include "../global/Basic.h"
#include "../global/KeyboardKey.h"

#include "../wrapper/Shortcut.h"


#include <map>
#include <set>
#include <vector>
namespace podo{
    class ShortcutInvoker {
	public:

		

		
		typedef Shortcut::ShortcutKeys ShortcutKeys;
		typedef Shortcut::ShortcutKey ShortcutKey;
		


		typedef std::set < ShortcutKey > ContinueData;
		typedef std::map < ShortcutKey, Shortcut* > CompleteData;
        
		
		CompleteData _oneCompleteData;
		ContinueData _oneContinueData;
		CompleteData _twoCompleteData;
		ContinueData _twoContinueData;
		CompleteData _thrCompleteData;

		uint32_t		_currentSequence;
		

	public:
			
		enum ProcessState{
		    Processed,
		    NotProcessed		    
		  };


		void registShortcutSequenceOne(ShortcutKeys const & shortcutKeys,Shortcut& shortcutListener) {
			
			_oneCompleteData[shortcutKeys[0] ] = & shortcutListener;

		}
		void registShortcutSequenceTwo(ShortcutKeys const & shortcutKeys,Shortcut&  shortcutListener) {
			
            _oneContinueData.insert( shortcutKeys[0] ) ;
			_twoCompleteData[shortcutKeys[1] ] = & shortcutListener;
		}
		void registShortcutSequenceThr(ShortcutKeys const & shortcutKeys,Shortcut&  shortcutListener) {
			
			_oneContinueData.insert( shortcutKeys[0] ) ;
			_twoContinueData.insert( shortcutKeys[1] ) ;

			_thrCompleteData[shortcutKeys[2] ] = & shortcutListener;
		}

		void unregistShortcutSequenceOne(ShortcutKeys  const & shortcutKeys) {
			 
			_oneCompleteData.erase( shortcutKeys[0] );

		}
		void unregistShortcutSequenceTwo(ShortcutKeys  const& shortcutKeys) {
			 
            _oneContinueData.erase( shortcutKeys[0] ) ;
			_twoCompleteData.erase( shortcutKeys[1] );
		}
		void unregistShortcutSequenceThr(ShortcutKeys const & shortcutKeys) {
			
			_oneContinueData.erase( shortcutKeys[0] ) ;
			_twoContinueData.erase( shortcutKeys[1] ) ;
			_thrCompleteData.erase( shortcutKeys[2] );
		}


		enum NextSequenceState {
			RESET,NEXT
		};

		NextSequenceState processShortcutSequenceOne(ShortcutKey const & shortcutKey) {
            			 
			if(_oneCompleteData.find(shortcutKey) != _oneCompleteData.end()) {
				_oneCompleteData[shortcutKey]->shortcutInvoked();

				return RESET;
			}

			if(_oneContinueData.find(shortcutKey) != _oneContinueData.end()) {				
				return NEXT;
			}

			return RESET;

		}

		NextSequenceState processShortcutSequenceTwo(ShortcutKey const & shortcutKey ){
			 
            if(_twoCompleteData.find(shortcutKey) != _twoCompleteData.end()) {
				_twoCompleteData[shortcutKey]->shortcutInvoked();
				return RESET;
			}

			if(_twoContinueData.find(shortcutKey) != _twoContinueData.end()) {
				return NEXT;
			}

			return RESET;
		}

		NextSequenceState processShortcutSequenceThr(ShortcutKey const & shortcutKey) {
			 
			if(_thrCompleteData.find(shortcutKey) != _thrCompleteData.end()) {
				_thrCompleteData[shortcutKey]->shortcutInvoked();
				return RESET;
				
			}
            
			return RESET;		
		}
		

		
		
	
		ShortcutInvoker(){
		    _currentSequence = 0;		    
		}
		
		void resetSequence() {
		    _currentSequence = 0;		  
		}
    public:
		static ShortcutInvoker& instance(){
           
			return *instancePtr();
		}

		static boost::shared_ptr<ShortcutInvoker>& instancePtr() {
			static boost::shared_ptr<ShortcutInvoker> instance (new ShortcutInvoker);
			return instance;

		}

		uint32_t const getShortcutSequence(ShortcutKeys  const & shortcutKeys){
			
			return static_cast<uint32_t>(shortcutKeys.size());
		}

		
		void registShortcut(ShortcutKeys const & shortcutKeys,Shortcut & shortcutListener) {




		    
		   

			if(getShortcutSequence(  shortcutKeys) == 0) {
				assertExp(false);
			}else if(getShortcutSequence( shortcutKeys) == 1 ) {
                this->registShortcutSequenceOne(shortcutKeys,shortcutListener)	;			
			}else if(getShortcutSequence( shortcutKeys) == 2) {
				 this->registShortcutSequenceTwo(shortcutKeys,shortcutListener)	;
			}else if(getShortcutSequence( shortcutKeys) == 3) {
				 this->registShortcutSequenceThr(shortcutKeys,shortcutListener)	;				
			}else {
				assertExp(false);
			}

		    
		    resetSequence();		    			
		}

		void unregistShortcut(ShortcutKeys const & shortcutKeys) {
		     

			if(getShortcutSequence( shortcutKeys) == 0) {
				assertExp(false);
			}else if(getShortcutSequence( shortcutKeys) == 1) {
                this->unregistShortcutSequenceOne(shortcutKeys)	;			
			}else if(getShortcutSequence( shortcutKeys) == 2) {
				 this->unregistShortcutSequenceTwo(shortcutKeys)	;
			}else if(getShortcutSequence( shortcutKeys) == 3) {
				 this->unregistShortcutSequenceThr(shortcutKeys)	;				
			}else {
				assertExp(false);
			}
		    
		    resetSequence();
		}
		
		
	
		ProcessState distributeMessage(KeyboardKey keyboardKey) {

			ShortcutKey shortcutKey(keyboardKey.getVirtualKey () ,keyboardKey.getControl () , keyboardKey.getShift() ,keyboardKey.getAlt() );

			if(isIgnoreKey(shortcutKey)) {
				return NotProcessed;
			}
			
			
			NextSequenceState result;

			if(_currentSequence == 0 ) {
				result = this->processShortcutSequenceOne (shortcutKey)	;	
			}else if(_currentSequence == 1) {
				result = this->processShortcutSequenceTwo(shortcutKey)	;
			}else if(_currentSequence  == 2) {
				result = this->processShortcutSequenceThr(shortcutKey)	;				
			}else {
				result = RESET;
				assertExp(false);
			}

			if(result == RESET) {
				this->resetSequence();
				return Processed;
			}else if(result == NEXT) {
				this->_currentSequence ++;
				return Processed;
			}else {
				return NotProcessed;
				assertExp(false);

			}		  
		}

		bool isIgnoreKey(ShortcutKey const& shortcutKey) {

			/*if(shortcutKey.getVirtualKey() == KeyboardKey::virtual_ALT) {
				return true;
			}*/

			if(shortcutKey.getVirtualKey() == KeyboardKey::VIRTUAL_CONTROL ) {
				return true;
			}


			if ( (!shortcutKey.getAlt()) && (!shortcutKey.getControl ()) ) {
                return true;
			}

			return false;

		}
        
    };
}



#endif //SHORTCUTOWNER_H

