/* Generated by Together */

#ifndef PODO_SYSTEM_WINDOW_H
#define PODO_SYSTEM_WINDOW_H
#include <boost/noncopyable.hpp>

#include "SystemApi.h"
#include "PaintDrawStruct.h"

#include "../global/Rect.h"

#include "MessageReceiver.h"

namespace podo {


class SystemWindow :public boost::noncopyable {




	private:
		//MessageReceiver & _receiver;





	public:

		InOutDrawStruct *createDrawStruct() ;

	

	protected:

		WindowID _windowId;
		
	public:




	

		SystemWindow(MessageReceiver & receiver, Point const &windowPoint, Size const & clientSize);
public:


		virtual ~SystemWindow() ;
		void repaint(Rect const &clientRect);
		Size const getClientSize() const;

		Point const clientToBackground(Point const &  pointOnClient ) ;
		void changeCaptureMode(bool const bCapture) {


		#ifdef _PODO_WIN32

			if(bCapture) {
				::SetCapture(_windowId);
			}else {
				::ReleaseCapture();
			}



		#elif defined(_PODO_POSIX)

		//none


		#endif




		}


		

		WindowID getWindowID() ;



		void postDestroyRequestMessage();


protected:
	void after(MessageReceiver & receiver ) ;

	

	};	


	class SystemCleanWindow:public SystemWindow {	
	public:
		SystemCleanWindow(MessageReceiver & receiver, Point const &windowPoint, Size const & clientSize);
				
	};




	class SystemFrameWindow :public SystemWindow{
	public:
		SystemFrameWindow(MessageReceiver & receiver, Point const &windowPoint, Size const & clientSize);


	};

}
#endif //PODO_SYSTEM_WINDOW_H

