/* Generated by Together */

#include "Application.h"
#include "../system/MessageQueue.h"
#include "../system/ApplicationInSystem.h"
#include "TopWindow.h"
#include "VolatileWindow.h"
#include "ModalWindow.h"
#include "FrameWindow.h"

namespace podo {





	int Application::run(){
		
		

		Message message;
		while(!_frameWindows.empty()  ) {		
			MessageQueue::nextMessage(message);
			if(true == ApplicationInSystem::instance().invokeShortcutMessage(message)) {
				continue;
			}

			ApplicationInSystem::instance().dispatchMessage(message);	
				
		}		

		return 0;
	}


	
		
	void Application::registFrameWindow(FrameWindowPtr  frameWindow ){		
		frameWindow->create();
		_frameWindows.push_back(frameWindow);
	}
	void Application::unregistFrameWindow(FrameWindow& frameWindow){
		for(size_t index  = 0; index < _frameWindows.size(); ++index) {
			if(_frameWindows[index].get() == &frameWindow) {
				_frameWindows[index]->destroy();

				assertExp(!_frameWindows[index]->isCreated());
				_frameWindows.erase(_frameWindows.begin() + index);
				return;
			}
		}
	}


	
	void Application::popModalWindow(ModalWindow& modalWindow){
		for(size_t index  = 0; index < _modalWindows.size(); ++index) {
			if(_modalWindows[index].get() == &modalWindow) {
				_modalWindows[index]->destroy();

				assertExp(!_modalWindows[index]->isCreated());
				_modalWindows.erase(_modalWindows.begin() + index);
				return;
			}
		}

	}

	void Application::pushModalWindow (ModalWindowPtr  modalWindow){
		
		_modalWindows.push_back(modalWindow);
		modalWindow->create();

		Message message;
		while(modalWindow->isCreated()  ) {	

			//trace(topWindow->isCreated() );
			MessageQueue::nextMessage(message);
			if(true == ApplicationInSystem::instance().invokeShortcutMessage(message)) {
				continue;
			}

			ApplicationInSystem::instance().dispatchMessage(message);	
				
		}		
	}
	

	
		
	void Application::pushVolatileWindow(VolatileWindowPtr volatileWindow) {
		_volatileWindows.push_back(volatileWindow);
		volatileWindow->create();
	}
	void Application::popVolatileWindow(VolatileWindow& volatileWindow){		
		if(_volatileWindows.back().get() == &volatileWindow) {
			volatileWindow.destroy();
			_volatileWindows.pop_back();
		}else {
			assertExp(false);
		}		
	}
	void Application::requestKillAllVolatileWindows() {


		size_t index = _volatileWindows.size();
		while( index-- ) {
			_volatileWindows[index]->postDestroyRequestMessage();
           			
		}
			
	}
	void Application::requestKillWhileVolatileWindows(VolatileWindow& volatileWindow){
		size_t index = _volatileWindows.size();
		while( index-- && (&volatileWindow != _volatileWindows[index].get()  )  ) {
			_volatileWindows[index]->postDestroyRequestMessage();
            //volatileWindows.pop_back();					
		}

	}

	bool const Application::hasVolatileWindow() {
		return _volatileWindows.size() != 0;
	}











	

	


}
