/* Generated by Together */

#ifndef BUTTON_H
#define BUTTON_H


#include "Component.h"
#include "listener/ActionListener.h"


#include "canvas/ChooseItemAbstractCanvas.p"
#include "ChooseItemMouseListener.h"
#include "data/ChooseData.h"
#include "data/WStringData.h"

namespace podo{






	class TextItem 
		:public Component 
		,public WStringDataHaver
		,public WStringView{


		
	public:

        template <typename TextItemAbstractCanvasPPP>
		TextItem(TextItemAbstractCanvasPPP canvas_p,WString const & wstr) {			

			boost::shared_ptr<TextItemAbstractCanvas> textitemCanvas (canvas_p);
			setCanvas(textitemCanvas);
            
			
			accessWStringData().registWStringView(*this);
			accessWStringData().setWString(wstr);			
			
		}


	protected:
		TextItem(WString const & wstr) {			

			//don' change Call Order;
			accessWStringData().setWString(wstr);		
			accessWStringData().registWStringView(*this);
		}
	public:
		
		virtual ~TextItem() {
			accessWStringData().unregistWStringView(*this);
		}

	private:
		virtual void wstringDataChanged() {
			repaint();
		}


	};

	
    class NormalChooseTextItem :public TextItem ,  public NormalChooseDataHaver, public NormalChooseView	{

			
	

		
    public:
        
        
		template<typename ChooseTextItemAbstractCanvasPPP >
		NormalChooseTextItem(ChooseTextItemAbstractCanvasPPP canvas_p,WString const & wstr = WString(L"  "))
		:TextItem(wstr){
			accessNormalChooseData().registNormalChooseView(*this);

			this->setCanvas(boost::shared_ptr<NormalChooseTextItemAbstractCanvas>(canvas_p));	
				
			this->setMouseListener(new ChooseTextItemMouseListener<NormalChooseData>(this->accessNormalChooseData()));			
			
		}
		

		virtual ~NormalChooseTextItem() {			
			accessNormalChooseData().unregistNormalChooseView(*this);
		}		


		virtual void normalChooseDataChanged() {
            repaint();
		}	

	
	
	        
	};


	 class CheckChooseTextItem :public TextItem ,  public CheckChooseDataHaver, public CheckChooseView	{

			
		

		
    public:
        
        
		template<typename ChooseTextItemAbstractCanvasPPP >
		CheckChooseTextItem(ChooseTextItemAbstractCanvasPPP canvas_p,WString const & wstr = WString(L"  "))
		:TextItem(wstr){
			accessCheckChooseData().registCheckChooseView(*this);
		
			this->setCanvas(boost::shared_ptr<CheckChooseTextItemAbstractCanvas>(canvas_p));	
				
			this->setMouseListener(new ChooseTextItemMouseListener<CheckChooseData>(this->accessCheckChooseData()));			
			
		}
		

		virtual ~CheckChooseTextItem() {			
			accessCheckChooseData().unregistCheckChooseView(*this);
		}		


		virtual void checkChooseDataChanged() {
            repaint();
		}	
	        
	};



	 
	 class RadioChooseTextItem :public TextItem ,  public RadioChooseDataHaver, public RadioChooseView	{

			
	

		
    public:
        
        
		template<typename ChooseTextItemAbstractCanvasPPP >
		RadioChooseTextItem(ChooseTextItemAbstractCanvasPPP canvas_p,WString const & wstr = WString(L"  "))
		:TextItem(wstr){
			accessRadioChooseData().registRadioChooseView(*this);

			this->setCanvas(boost::shared_ptr<RadioChooseTextItemAbstractCanvas>(canvas_p));	
				
			this->setMouseListener(new ChooseTextItemMouseListener<RadioChooseData>(this->accessRadioChooseData()));			
			
		}
		

		virtual ~RadioChooseTextItem() {			
			accessRadioChooseData().unregistRadioChooseView(*this);
		}		


		virtual void radioChooseDataChanged() {
            repaint();
		}	
	        
	};



	

	
    typedef boost::shared_ptr<NormalChooseTextItem> NormalChooseTextItemPtr;
    typedef NormalChooseTextItem Button;typedef boost::shared_ptr<Button> ButtonPtr;
	
    
   
    typedef boost::shared_ptr<CheckChooseTextItem> CheckChooseTextItemPtr;
	typedef CheckChooseTextItem CheckButton;typedef boost::shared_ptr<CheckButton> CheckButtonPtr;
	
    
   
    typedef boost::shared_ptr<RadioChooseTextItem> RadioChooseTextItemPtr;  
    typedef RadioChooseTextItem RadioButton;typedef boost::shared_ptr<RadioButton> RadioButtonPtr;  





}

#endif
//BUTTON_H

