/* Generated by Together */

#ifndef COMPONENT_H
#define COMPONENT_H

#include "Component.p"

#include "canvas/Canvas.h"
#include "listener/MouseListener.h"
#include "listener/KeyListener.h"
#include "listener/SizeListener.h"
#include "listener/CharactorListener.h"
#include "listener/ComponentListener.h"
#include "listener/GetDragDataListener.h"
#include "listener/FocusListener.h"


#include "data/EnableData.h"

#include "../global/Rect.p"
#include "../global/Size.p"
#include "TopWindow.p"
#include "Container.p"
#include "painter/InOutGraphics.p"




namespace podo{
	
	


    class Component :		
		public CanvasHaver, 
		public MouseListenerHaver, 
		public KeyListenerHaver,
		public SizeListenerHaver,
		public CharactorListenerHaver ,
		public ComponentListenerHaver ,		
        public GetDragDataListenerHaver,
		public FocusListenerHaver
	{
		

    private : 
			
		Container * _parent_p;
	public :
		Component();
		virtual ~Component();



        Container const & getParent() const {
            assertExp(hasParent());
            return *_parent_p;
        }

        Container & accessParent() {
            assertExp(hasParent());
            return *_parent_p;
        }

        void setParent(Container & parent) {
            assertExp(!hasParent());
           _parent_p = & parent;
        }

        void removeParent() {
            assertExp(hasParent());
           _parent_p = NULL;

        }

        bool hasParent() const {
            return _parent_p != NULL;
        }



		virtual Component & findComponent(Point const & /*point_r*/) {
			return *this;
		}


		virtual void draw(InOutGraphics &graphics) {

			invokeCanvas(graphics);			
			
		}

	
		

		virtual bool const isOkToExit()  {


			ComponentEventComponentCloseOk  event;
			invokeComponentListener(event);


			trace ("comp Occurb " <<event.isOk() );

			return event.isOk();
		}


		virtual String const toString() const {
			if(hasParent()){
				return  String("Parent : have") ;

			}	else {
				return String ("Parent : Not have");

			}
		}

		virtual void dataChanged()  {
			repaint();
		}

		//virtual bool const isEnable() const ;

		Point const getPointOnClient() const;
		Rect const getRectOnClient() 	const;	
		Point const getPointOnParent() const;
		Rect const getRectOnParent() const;		
		Rect const  getClippingRectOnClient() const;
		Size const getSize() const ;

		void repaint() ;
		void requestFocus();
		//void repaint(Rect const & rect) ;




		static ComponentPtr createNull() ;
		static ComponentPtr createTemp() ;

		TopWindow const & getTopWindow() const ;
		TopWindow  & accessTopWindow() ;
		bool const hasTopWindow() const ;





    };


	


}

#endif //COMPONENT_H


