#include "ComponentRegionUtil.h"
#include "ComponentChainUtil.h"
#include "TopWindowClientComponentMatcher.h"
#include "Container.h"
#include "../global/Rect.h"
#include "TopWindow.h"
#include "FrameWindow.h"


using namespace std;

namespace podo{

	
	

	Rect const ComponentRegionUtil::getRectOnParent(Component const & component)  {	
		if (ComponentChainUtil::isClientComponent(component) ) {
			if(TopWindowClientComponentMatcher::hasTopWindow(component)){
				Size size = TopWindowClientComponentMatcher::getTopWindow(component).getClientSize();
				Point point(0,0) ;
				return Rect(point,size);

			}else {
				assertExp(false);
				return Rect();

			}			
		}else {
			Rect result = component.getParent().getChildRect(component);
			return result;
		}

	}

	Rect const  ComponentRegionUtil::getRectOnClient(Component  const& component)  {

		if (ComponentChainUtil::isClientComponent(component) ) {
            return getRectOnParent(component);			
		}else {
			Point parentPoint = getRectOnClient(component.getParent()).toPoint();
			Point pointOnParent = getRectOnParent(component).toPoint();
			Point myPoint = parentPoint + pointOnParent;

			Size size = getRectOnParent(component).toSize();
			return Rect(myPoint,size)	;
		}
	}

	Rect const  ComponentRegionUtil::getClippingRectOnClient(Component  const& component) {
		if (ComponentChainUtil::isClientComponent(component) ) {
			return getRectOnClient(component);
		}else {
			return getRectOnClient(component) & getClippingRectOnClient(component.getParent());
		}
	}

	Point const ComponentRegionUtil::getPointOnParent(Component const & component) {
		Point result = getRectOnParent(component).toPoint();
		return result;
		
	}


	Point const ComponentRegionUtil::getPointOnClient(Component const & component) {
		Point result = getRectOnClient(component).toPoint();
		return result;	

	}	


	Size const ComponentRegionUtil::getSize(Component  const& component) {		
        Size result = getRectOnParent(component).toSize();
		return result;
		
	}

	


}


