#ifndef PODO_CREATEDCOMPONENTS_H_
#define PODO_CREATEDCOMPONENTS_H_
#include <set>

namespace podo{
    class CreatedComponents {
        private:
        std::set<Component const*> _data;
        CreatedComponents() {           
        } 
        public:
        static CreatedComponents & instance() {
            static CreatedComponents instance;
            return instance;
        }
        
        void addComponent(Component& component) {
            assertExp(!hasComponent(component));
            _data.insert(&component);
            
        }
        
        void subComponent(Component& component) {
            assertExp(hasComponent(component));
            _data.erase(&component);           
        }
        
        bool const hasComponent(Component const&component) const {
            return _data.find(&component) != _data.end();
            
        }        
    };    
}
#endif 
//PODO_CREATEDCOMPONENTS_H_


