#include "Edit.h"
#include "canvas/EditAbstractCanvas.h"

#include "ComponentEtcUtil.h"
#include "data/WStringData.h"


namespace podo{

	Edit::Edit(EditAbstractCanvasPtr canvas_p) { 
		init(canvas_p);
	}

	Edit::Edit(EditAbstractCanvas* canvas_p) { 
		init(EditAbstractCanvasPtr(canvas_p) );
		
	}

	void Edit::init(EditAbstractCanvasPtr canvas_p) {
		this->setCanvas(canvas_p);	
		this->addMouseListener(new MouseThisListener(*this));
		this->setCharactorListener (new CharactorThisListener(*this));

		WStringDataHaver::accessWStringData().registWStringView(*this);

	}


	void Edit::mousePressed(MouseListenerHaver & sender, MouseEventButtonPressed & event) {

		ComponentEtcUtil::requestFocus(*this);	
	}



	void  Edit::setString(CharactorListenerHaver &sender, CharactorEventSetString & event) {
		this->accessWStringData().access();
		if(accessWStringData().access() .size() > 0) {
			accessWStringData().access()[accessWStringData().access().size() - 1 ] =  event.ch ;
			
		}
		
	}

	void  Edit::addString(CharactorListenerHaver &sender, CharactorEventAddString & event) {
		accessWStringData().access() += event._ch ;	
		ComponentEtcUtil::repaint(*this);
	}

	void  Edit:: subString(CharactorListenerHaver &sender, CharactorEventSubString & event)  {
		if(accessWStringData().access() .size() > 0) {
			accessWStringData().access().resize(accessWStringData().access().size() -1 );
			ComponentEtcUtil::repaint(*this);
		}		
	}
   
}


