/* Generated by Together */

#ifndef FLOWLAYOUTMANAGER_H
#define FLOWLAYOUTMANAGER_H


#include "LineLayoutManager.h"
#include "listener/SizeListener.h"


namespace podo{




	struct HorizontalLayoutFunc {

		Rect computeComponentRect(size_t const index 
			,uint16_t _flowWidth 	,uint16_t _flowHeight 
			,uint16_t _flowLeftGab 	,uint16_t _flowUpperGab 
			,uint16_t _flowRightGab 	,uint16_t _flowBottomGab
			,Size _containerSize) {


			size_t const ableCount = std::max < int > (_containerSize.getWidth() / _flowWidth, 1);	

			size_t level = index / ableCount;
			size_t nth = index % ableCount;
			
			Rect newRect =
				Rect(int32_t(nth * _flowWidth) + _flowLeftGab, 
				int32_t(level * _flowHeight) + _flowUpperGab,
				_flowWidth - _flowLeftGab - _flowRightGab ,
				_flowHeight - _flowUpperGab - _flowBottomGab ) ;
			

			return newRect;

		}
	};

	struct VerticalLayoutFunc {

		
		Rect computeComponentRect(size_t const index 
			,uint16_t _flowWidth 	,uint16_t _flowHeight 
			,uint16_t _flowLeftGab 	,uint16_t _flowUpperGab 
			,uint16_t _flowRightGab 	,uint16_t _flowBottomGab 
			,Size _containerSize) {


			size_t const ableCount = std::max < int > (_containerSize.getHeight() / _flowHeight, 1);	

			size_t level = index / ableCount;
			size_t nth = index % ableCount;
			
			Rect newRect =
				Rect(int32_t(level * _flowWidth) + _flowLeftGab, 
				int32_t(nth * _flowHeight) + _flowUpperGab,
				_flowWidth - _flowLeftGab - _flowRightGab ,
				_flowHeight - _flowUpperGab - _flowBottomGab ) ;
			

			return newRect;

		}

	};
    


    template <typename LayoutFunc ,uint16_t flowWidth = 100	
		, uint16_t flowHeight = 25	
		, uint16_t flowLeftGab = 2
		, uint16_t flowUpperGab = 2
		, uint16_t flowRightGab = flowLeftGab
		, uint16_t flowBottomGab = flowUpperGab	>
    class FlowLayoutManager : public LineLayoutManager {
        typedef LineLayoutManager super;
		
		
		
	private:
		//only for check 
		char ccc[flowWidth - flowLeftGab - flowLeftGab - 2 ] ;
		char ddd[flowHeight - flowUpperGab - flowUpperGab  - 2];

		bool check() {
			if((_flowWidth  >  (_flowLeftGab + _flowLeftGab + 2) )
				&&	(flowHeight >( flowUpperGab - flowUpperGab  + 2) ) ) {
				return true;
			}else {
				return false;

			}

		}

	





	protected:
		uint16_t _flowWidth 	;
		uint16_t _flowHeight  ;
		uint16_t _flowLeftGab ;
		uint16_t _flowUpperGab  ;
		uint16_t _flowRightGab ;
		uint16_t _flowBottomGab ;

		FlowLayoutManager () {
			_flowWidth = flowWidth	;
			_flowHeight = flowHeight ;
			_flowLeftGab = flowLeftGab;
			_flowUpperGab = flowUpperGab ;
			_flowRightGab = flowRightGab;
			_flowBottomGab = flowBottomGab;
		}

	public:

		uint16_t const getFlowWidth() const{
			return _flowWidth;
		}
		uint16_t const getFlowHeight() const{
            return _flowHeight;
		}
		uint16_t const getFlowLeftGab() const{
			return _flowLeftGab;
		}
		uint16_t const getFlowRightGab() const{
            return _flowRightGab;
		}
		uint16_t const getFlowUpperGab() const{
			return _flowUpperGab;
		}
		uint16_t const getFlowBottomGab() const{
			return _flowBottomGab;
		}

		void setFlowWidth(uint16_t const initflowWidth) {
			_flowWidth = initflowWidth;
		}
		void setFlowHeight(uint16_t const initflowHeight) {
            _flowHeight = initflowHeight;
		}
		void setFlowLeftGab(uint16_t const initflowLeftGab) {
			_flowLeftGab = initflowLeftGab;
		}
		void setFlowRightGab(uint16_t const initflowRightGab){
            _flowRightGab= initflowRightGab;
		}
		void setFlowUpperGab(uint16_t const initflowUpperGab) {
			_flowUpperGab = initflowUpperGab;
		}
		void setFlowBottomGab(uint16_t const initflowBottomGab) {
			_flowBottomGab = initflowBottomGab;
		}
     


        void addComponent(Component * component_p) {
            ComponentPtr temp(component_p);
            addComponent(temp);
        }



		void addComponent(ComponentPtr component_p) {
			_datas.push_back(ValueType( component_p, Rect()  ));
			super::registComponent(*component_p);
		}



		virtual void resiteChild(Size const &_containerSize) {

			LayoutFunc func;	        
			

			for (size_t index = 0; index < _datas.size()  ; ++index) {			
			    
				Rect newRect = func.computeComponentRect(index 	,_flowWidth 	,_flowHeight 
                    ,_flowLeftGab 	,_flowUpperGab 	,_flowRightGab 	, _flowBottomGab 	,_containerSize);

				
				_datas[index] . replaceRect(newRect);

				Size const childSize = newRect.toSize();

				//SizeEventSizeChanged eventToComponent   (childSize);
				//_datas[index].accessComponent().invokeSizeListener(eventToComponent );


			}
		}





    };

	 template <uint16_t _flowWidth = 100
		, uint16_t _flowHeight = 25	
		, uint16_t _flowLeftGab = 2
		, uint16_t _flowUpperGab = 2
		, uint16_t _flowRightGab = _flowLeftGab
		, uint16_t _flowBottomGab = _flowUpperGab	>
	 class VerticalFlowLayoutManager 
		 :public  FlowLayoutManager<VerticalLayoutFunc  , _flowWidth 	,  _flowHeight 	,  _flowLeftGab 	
		 ,  _flowUpperGab,  _flowRightGab ,  _flowBottomGab > {

	 };

	 template <uint16_t flowWidthCount = 1	
		, uint16_t flowHeight = 25	
		, uint16_t flowLeftGab = 2
		, uint16_t flowUpperGab = 2
		, uint16_t flowRightGab = flowLeftGab
		, uint16_t flowBottomGab = flowUpperGab	>
	 class XVerticalFlowLayoutManager
		 : public VerticalFlowLayoutManager<100,flowHeight,flowLeftGab,
			flowUpperGab,flowRightGab,flowBottomGab> {
		typedef VerticalFlowLayoutManager<100,flowHeight,flowLeftGab,
			flowUpperGab,flowRightGab,flowBottomGab> super;
		char cc[flowWidthCount ];
		 
	 public:
		virtual void resiteChild(Size const &_containerSize) {

			uint16_t width = std::max<int>(
				(_containerSize.getWidth() / flowWidthCount),
				(2 + flowLeftGab + flowRightGab) 
				);

			setFlowWidth(width);

			super::resiteChild(_containerSize);

			
		}


	 };


	  template <uint16_t _flowWidth = 100	
		, uint16_t _flowHeight = 25	
		, uint16_t _flowLeftGab = 2
		, uint16_t _flowUpperGab = 2
		, uint16_t _flowRightGab = _flowLeftGab
		, uint16_t _flowBottomGab = _flowUpperGab	>
	  class HorizontalFlowLayoutManager 
		  :public FlowLayoutManager<HorizontalLayoutFunc   , _flowWidth 	,  _flowHeight , 
		  _flowLeftGab 	,  _flowUpperGab ,  _flowRightGab 	,  _flowBottomGab>	 {


	 };


	   template <uint16_t flowWidth = 100	
		, uint16_t flowHeightCount = 1	
		, uint16_t flowLeftGab = 2
		, uint16_t flowUpperGab = 2
		, uint16_t flowRightGab = flowLeftGab
		, uint16_t flowBottomGab = flowUpperGab	>
	 class XHorizontalFlowLayoutManager
		 : public HorizontalFlowLayoutManager<flowWidth,25,flowLeftGab,
			flowUpperGab,flowRightGab,flowBottomGab> {
		typedef HorizontalFlowLayoutManager<flowWidth,25,flowLeftGab,flowUpperGab,flowRightGab,flowBottomGab> super;

		char cc[flowHeightCount];

	 public:
		 
		virtual void resiteChild(Size const &_containerSize) {


			
			uint16_t width = std::max(
				(_containerSize.getHeight() / flowHeightCount),
				(2 + flowTopGab + flowBottomGab) 
				);

			setFlowHeight(height);

			super::resiteChild(_containerSize);


			
		}


	 };





}

#endif
//FLOWPANEL_H



