/* Generated by Together */

#ifndef LAYOUTMANAGER_H
#define LAYOUTMANAGER_H


#include "Component.p"
#include "../global/Size.p"
#include "../global/Point.p"
#include "../global/Rect.h"

#include "painter/InOutGraphics.p"
#include "Container.p"
#include "../global/String.h"
namespace podo{

	class LayoutManager {

	private:
		Container * _parent;

	protected:        

		

		void registComponent(Component & comp) ;
		void unregistComponent(Component & comp);

	public:

		LayoutManager():_parent(NULL) {

		}
		virtual ~LayoutManager() {

		}


		virtual void init(Container & container) {
			_parent = &container;
		}
		virtual void exit() {
			_parent = NULL;
		}


		virtual Rect const getChildRect(Component const & )const =0;		
		virtual Component  & findComponentAtChild(Point const & point)   =0;
        virtual void resiteChild(Size const &size) = 0;
		virtual void drawChild(InOutGraphics &graphics) = 0;
		virtual bool const isOkToExit() = 0;		
        virtual bool const  empty() const  = 0;
		virtual  String const toString() const = 0;


	protected:

		class ValueType {
			ComponentPtr _component;
			Rect		_rect;
		public:
			ValueType( ComponentPtr component,Rect	rect):
				_component(component),_rect(rect) {

			}

			bool const hasComponent() const {
                return _component.get() != NULL;
			}

			void replaceRect(Rect const newRect) {
				_rect = newRect;
			}
			Rect const getRect() const {
				return _rect;
			}

			Component &  accessComponent() {
				return * _component;
			}
			Component &  getComponent() const {
				return * _component;
			}


			ComponentPtr shareComponent() {
				return _component;
			}
		};

	protected:
		
	};

}
#endif
//LAYOUTMANAGER_H

