
#ifndef PANEL_H
#define PANEL_H
#include "Container.h"
#include "LayoutManager.h"
#include "painter/InOutGraphics.p"
#include "../global/Rect.h"





namespace podo{

    template < typename LAYOUTMANAGER >
    class Panel : public Container {
		typedef Panel this_t;

    private:
        /** @link aggregation */
        LAYOUTMANAGER  _layoutManager;

    public:

		struct PanelSizeListener :public SizeListener {
			this_t &_this;
			PanelSizeListener(this_t &this_r) : _this(this_r) {

			}
			virtual void sizeChanged(SizeListenerHaver &sender, SizeEventSizeChanged &event ) {
				_this._layoutManager.resiteChild(event._size);	
			}
		};
		friend struct PanelSizeListener;


        Panel() {
            _layoutManager.init(*this);

			addSizeListener(new PanelSizeListener(*this));
        }
        virtual ~Panel() {
            _layoutManager.exit();
        }

        LAYOUTMANAGER &accessContentsPane(){
            return _layoutManager;
        }
		
		
		
		//Container   ...
	
		virtual Rect const  getChildRect(Component const & component ) const {        
            return _layoutManager.getChildRect(component);
        }



		//Component    

        virtual Component & findComponent(Point const & point) {

			//̰ ڽĿ  ã  ڽ  Component ൿ ..

			Component & result = _layoutManager.findComponentAtChild(point) ;
			if(Component::createNull().get()  == &result ){			
				return Component::findComponent(point);
			}

			return result;
		}
		virtual void draw(InOutGraphics &graphics) {

			trace("draw");
			//̰  ߿ ϴ...
			//ڽ  ׸ ڽ ڿ ׷  ߻ ʴ´.
			Component::draw (graphics);
			_layoutManager.drawChild(graphics);
		}

	public:

		virtual bool const isOkToExit()  {


			trace("\npanel Occur");
			return Component::isOkToExit () &&
				_layoutManager.isOkToExit();
		}

		virtual String const toString() const {
			return Component::toString() + _layoutManager.toString();

		}


    public:



    };

}
#endif
//PANEL_H
