/* Generated by Together */

#ifndef SCROLL_H
#define SCROLL_H

#include "Scroll.p"

#include "Component.h"

#include "../global/String.h"
#include "data/ScrollData.h"
#include "../global/Rect.h"


#include "../global/InnerClass.h"
#include "ComponentEtcUtil.h"




namespace podo{
    class Scroll : public Component, public ScrollView {

	



    protected:
		/** @link aggregation */
        ScrollDataPtr data;
        static const unsigned int MUST_PAGE_SIZE = 3;
        static const unsigned int LOW_ARROW_SIZE = 15;
        static const unsigned int HIGH_ARROW_SIZE = 15;

        static const unsigned int MUST_SCROLL_SIZE = LOW_ARROW_SIZE + MUST_PAGE_SIZE + HIGH_ARROW_SIZE;



		
		Rect lowArrowRect;
		Rect lowBodyRect;
		Rect pageRect;
		Rect highBodyRect;
		Rect highArrowRect;

		bool bPageDragMode;
private:

protected:
		
	public:

		Rect getLowerArrowRect() const{		
			return lowArrowRect;	
		}
	

		Rect getLowerBodyRect() const{
			return  lowBodyRect;
		}

		Rect getPageRect() const{	
			return pageRect;
		}
	
		Rect getHigherBodyRect() const{
			return highBodyRect;	
		}

		Rect getHigherArrowRect() const{	
			return highArrowRect;
		}

		virtual void computeRects()  = 0;
		virtual uint32_t const getMoveableLimits() = 0;

        Scroll();
        ~Scroll();


      

		

		uint32_t const convertViewValueToDataValue(uint32_t toCompute);

		uint32_t const convertDataValueToViewValue(uint32_t toCompute);

        ScrollDataPtr getScrollData() {
            return data;
        }

        void setScrollData(ScrollDataPtr initData) ;

        virtual void scrollDataChanged(ScrollData const & /*scrollData_r*/);



	public:

		class ScrollMouseListener :public MouseListener ,public InnerClass< Scroll>{
		public:

			ScrollMouseListener( Scroll & this_r) :InnerClass< Scroll>(this_r){

			}

			// ۿ ϶ ߻ ϴ ޼          
			virtual void mousePressed(MouseListenerHaver & sender, MouseEventButtonPressed & event) {

			Rect rectLow = _this.getLowerArrowRect();
			Rect rectHigh =  _this.getHigherArrowRect();
			Point currentPoint = event.getCurrentPointOnClient () - _this.getPointOnClient() ;
			if(_this.getLowerArrowRect().isIn(currentPoint )) {
				_this.data->setMaybePos(std::max<int>(_this.data->computePos() - 5, 0));
				
				

			}else if(  _this.getHigherArrowRect().isIn(currentPoint )  ) {
				_this.data->setMaybePos(_this.data->computePos() + 5);
				
			}else if(  _this.getLowerBodyRect().isIn(currentPoint )  ) {
				_this.data->setMaybePos(std::max<int>(_this.data->computePos() - _this.data->getPage(), 0));

			}else if(  _this.getHigherBodyRect().isIn(currentPoint )  ) {
				_this.data->setMaybePos(_this.data->computePos() + _this.data->getPage());
			}else if( _this.getPageRect().isIn(currentPoint) ){
                _this.bPageDragMode = true;
				//none
			}else {
				assertExp(false);

			}


			


			}
			virtual void mouseClicked(MouseListenerHaver & sender,MouseEventButtonClicked  &event) {
				_this.bPageDragMode = false;
			}
			virtual void mouseDroped(MouseListenerHaver & sender,MouseEventDroped  &event) {
				_this.bPageDragMode = false;

			}
			//  ߻ ϴ ޼		
			virtual void mouseDraged(MouseListenerHaver & sender,MouseEventDraged  &event) {



				if(_this.bPageDragMode ) {

				
					int32_t  gab = getGab(event);

					if(gab > 0) {
						_this.data->setMaybePos(_this.data->computePos() + _this.convertViewValueToDataValue( gab ));

					}
					else if (gab < 0) {
						
						int32_t toMove = _this.convertViewValueToDataValue( -gab );

						/*if(toMove >= static_cast<int32_t>(_this.data->computePos()) ) {
							_this.data->setMaybePos( 0);
						}
						else {*/
						_this.data->setMaybePos( std::max<int>(0,_this.data->computePos() - toMove));
						/*}*/
						


					}
					else {
						//none;

					}
					

					

				}


				
			}
			virtual void mouseMoved(MouseListenerHaver & sender,MouseEventMouseMoved  &event) {

			}
			virtual void mouseExited(MouseListenerHaver & sender,MouseEventMouseExited  &event) {

			}
			virtual void mouseEntered(MouseListenerHaver & sender,MouseEventMouseEntered  &event) {

			}

			
			
		public:
			virtual int32_t const getGab(MouseEventDraged const &event)  = 0;
			

		};

    };
}
#endif //SCROLL_H
