/* Generated by Together */

#ifndef SHORTCUT_H
#define SHORTCUT_H

#include "Shortcut.p"
#include "../global/Debug.h"
#include "../global/KeyboardKey.h"
#include "listener/ShortcutListener.h"



#include <vector>
namespace podo{
	

	class ShortcutInvoker;
	class Shortcut :public ShortcutListenerHaver  {
		public:		
            
			struct ShortcutKey {     
			private:
			
				KeyboardKey::Virtualkey _virtualKey;
				bool _bShift;
				bool _bControl;
				bool _bAlt;

				
			public:
			

				ShortcutKey(KeyboardKey::Virtualkey virtualKey,bool bControl,bool bShift,bool bAlt) {

					_virtualKey = virtualKey ;
					_bShift = bShift;
					_bControl = bControl;
					_bAlt =bAlt;

					//_shortcutInvoker = 
				}
				

				bool const getShift() const{
					return _bShift;
				}

				bool const getControl() const{
					return _bControl;
				}

				bool const getAlt() const{
					return _bAlt;
				}
				KeyboardKey::Virtualkey getVirtualKey () const{
					return _virtualKey;
				}

			friend bool const operator < (ShortcutKey const & left,ShortcutKey const & right ) {
	    
					if (left.getVirtualKey() < right.getVirtualKey()) {
						return true;
					}    
					if (left.getVirtualKey() > right.getVirtualKey()) {
						return false;
					}    
	    
					if (!left.getShift() && right.getShift()) {
						return true;
					}
					if (left.getShift ()&& !right.getShift()) {
						return false;
					}
	    
					if (!left.getControl() && right.getControl()) {
						return true;
					}
					if (left.getControl ()&& !right.getControl()) {
						return false;
					}  
	                
					if (!left.getAlt() && right.getAlt()) {
						return true;
					}
					if (left.getAlt ()&& !right.getAlt()) {
						return false;
					}                  
	    
					return false;    
				}
	            
				friend bool const operator == (ShortcutKey const & left,ShortcutKey const & right ) {
				return (left.getVirtualKey() == right.getVirtualKey()) &&
						(left.getControl() == right.getControl())&&
						(left.getShift() == right.getShift()) &&
						(left.getAlt ()== right.getAlt());
				}
	   
			}; 

			typedef std::vector<ShortcutKey> ShortcutKeys;

			
			
					       
		private:				
			ShortcutKeys _shortcutKeys;		

			//just resolve Destroy Ordering;
			boost::shared_ptr<ShortcutInvoker> _shortcutInvoker;


			


		public:

			Shortcut(ShortcutKey const &shortcutKey);
			~Shortcut();

			


			ShortcutKeys const &getShortcutKeys() const{
				return _shortcutKeys;
			}

			void shortcutInvoked() {      
				ShortcutEvent event;
				this->invokeShortcutListener(event);

			

			}


			
			
		};

	
}

#endif
//SHORTCUT_H
