/* Generated by Together */

#include "TopWindow.h"
#include "Application.h"
#include "../global/Rect.h"
#include "TopWindowClientComponentMatcher.h"
#include "Component.h"
#include "CreatedComponents.h"

#include "painter/InOutGraphics.h"
#include "../system/PaintDrawStruct.h"
#include "../system/WindowDrawStruct.h"
#include "../system/SystemWindow.h"

#include "language/Receivable.h"
#include "language/LanguageSystem.h"
#include "../global/InnerClass.h"
#include "ComponentChainUtil.h"




#include "process/MouseOut.h"
#include "process/MouseBeforeIn.h"
#include "process/MouseIn.h"
#include "process/MouseInDrag.h"
#include "process/MouseBeforeDrag.h"
#include "process/MouseOutDrag.h"

#include "process/MouseStateFactory.h"

#include "../global/MouseButton.h"

#include "Application.h"

#include "../system/win32/InstanceHandle.h"


#include "VolatileWindow.h"


namespace podo{



	
	TopWindow::TopWindow()	:_windowImpl(NULL)	{		

		this->addFocusListener(new TopWindowFocusListener(*this));
		this->addSizeListener(new TopWindowSizeListener(*this));

		this->_topComponent  = Component::createTemp();
		TopWindowClientComponentMatcher::linkTopWindow(*_topComponent,*this);
		
		reset();
	} 

	

	TopWindow::~TopWindow() {
		assertExp( !this->isCreated() );

		TopWindowClientComponentMatcher::unlinkTopWindow(*_topComponent);
		this->_currentMouseState.reset();			

		
	}




	void TopWindow::reset() {
		this->setFocusedComponent (*_topComponent);	
		this->_currentMouseState = MouseStateFactory::createOut();

		if(isCreated() == true) {
			Size size =this->getClientSize();


			SizeEventSizeChanged eventToComponent(size);
			_topComponent->invokeSizeListener(eventToComponent );	
			
			_windowImpl  -> repaint(Rect(Point() ,this->getClientSize() ) );
         }
	}


	
	

	

	void TopWindow::setFocusedComponent(Component & comp) {

		if(&comp ==  _currentFocusedComponent){

			return;
		}

		if(CreatedComponents::instance().hasComponent(*_currentFocusedComponent) 
			&& ComponentChainUtil::isChainOk(*_currentFocusedComponent) ) {

			FocusEventFocusLost event;
			
			_currentFocusedComponent ->invokeFocusListener(event);
		}

		_currentFocusedComponent = &comp ;

		if(CreatedComponents::instance().hasComponent(*_currentFocusedComponent) 
			&& ComponentChainUtil::isChainOk(*_currentFocusedComponent) ) {

			FocusEventFocusGained event;
			
			_currentFocusedComponent ->invokeFocusListener(event);
		}

	}


	
	void TopWindow::setClientComponent(ComponentPtr topComponent){


		
		
		TopWindowClientComponentMatcher::relinkTopWindow(*_topComponent,*topComponent, *this);
		_topComponent =  topComponent;

		if(isCreated() == true) {
			Size size =this->getClientSize();

			SizeEventSizeChanged eventToComponent(size);
			_topComponent->invokeSizeListener(eventToComponent );	
		
			_windowImpl  -> repaint(Rect(Point() ,this->getClientSize() ) );

         }

		
		
			

		
	}


	void TopWindow::setClientComponent(Component* topComponent){
			ClientComponentPtr temp(topComponent);
			setClientComponent(temp);
	}


	void TopWindow::afterCreated() {
		reset();
	}




	Size const TopWindow::getClientSize() const{
		return this->_windowImpl->getClientSize();
	}



	void TopWindow::postDestroyRequestMessage(){		
		_windowImpl->postDestroyRequestMessage();
	}

	InOutGraphicsPtr TopWindow::createGraphics() {
		
		InOutGraphics * graphics = new InOutGraphics( this->_windowImpl ->createDrawStruct() );
		return InOutGraphicsPtr(graphics);
	}



	Point const TopWindow::clientToBackground(Point const &  pointOnClient ) {


	
		return _windowImpl->clientToBackground( pointOnClient);

	}



	void TopWindow::ChangeMouseState(MouseStatePtr mouseState) {
		trace("\n change MouseState : "<< _currentMouseState->toString() << "==> " << mouseState->toString() );

		//콺 ¸ ٲٰ ̺Ʈ ó  , MouseStateο     ϱ ؼ
		// ¸  ϰ ִ´.
		static MouseStatePtr oldState ;
		oldState = _currentMouseState;

		_currentMouseState = mouseState;

		 
	}

	void TopWindow::ChangeMouseStateIllegal(MouseStatePtr mouseState) {
		trace("\n change MouseState : "<< _currentMouseState->toString() << "~~> " << mouseState->toString() );

		//콺 ¸ ٲٰ ̺Ʈ ó  , MouseStateο     ϱ ؼ
		// ¸  ϰ ִ´.
		static MouseStatePtr oldState ;
		oldState = _currentMouseState;

		_currentMouseState = mouseState;

		 
	}

	


	MessageReceiver::ProcessState TopWindow::distributeMouseButtonMessage(bool const & bDowned, MouseButton const& button,Point const & pointOnClient,bool bIn){
		


		if(bDowned ) {
			_windowImpl->changeCaptureMode(true);
			_currentMouseState->distributeAtMouseButtonDown (*this,this->_topComponent ,true,pointOnClient,button,bIn);   
		}else {
			_windowImpl->changeCaptureMode(false);
			_currentMouseState->distributeAtMouseButtonUp(*this,this->_topComponent ,true,pointOnClient,button,bIn);            
       	}


		return Processed;
	}

    MessageReceiver::ProcessState TopWindow::distributeKeyMessage(bool const & bDowned, KeyboardKey  const& key){



		trace("key"<<(int) key.getVirtualKey());



        class Receive :public Receivable, InnerClass<TopWindow> {
		public:
            Receive(TopWindow & this_r ) :InnerClass<TopWindow>(this_r) {
            }


			virtual void setString(wchar_t const ch, bool const & bCompositeState) {
				CharactorEventSetString event(ch, bCompositeState);

				_this._currentFocusedComponent->invokeCharactorListener(event);
				
			}

			virtual void addString(wchar_t const ch, bool const & bCompositeState) {
				CharactorEventAddString event(ch, bCompositeState);
				_this._currentFocusedComponent->invokeCharactorListener(event); 
			}

			virtual void subString(bool const &bCompositeState){
				CharactorEventSubString event(bCompositeState);
				_this._currentFocusedComponent->invokeCharactorListener(event);  
			}
			
			               
        };

		


		if(bDowned == true) {
				
			if(ComponentChainUtil::isChainOk(*_currentFocusedComponent)) {
				
		        
				Receivable *receive = new Receive (*this);
				LanguageSystem::instance().addReceivable(*receive);    
				LanguageSystem::instance().input(key);
				LanguageSystem::instance().subReceivable(*receive);
				delete receive;      
		        
				KeyEventKeyPressed event(key);
				

				_currentFocusedComponent->invokeKeyListener(event);
				
		        
			}
			else {
				//none;	                
			}

		}else {

				if(ComponentChainUtil::isChainOk(*_currentFocusedComponent)) {
					
					
			        
					KeyEventKeyReleased event(key);
					_currentFocusedComponent->invokeKeyListener(event);
			        
				}
				else {
					//none;	                
				}
		}

		

       
		return Processed;
		
	}
	
	MessageReceiver::ProcessState TopWindow::distributePaintMessage(PaintDrawStruct & paintDrawStruct){
		InOutGraphics graphics(paintDrawStruct);
	   	  
		_topComponent->draw(graphics);					
		

		return Processed;
    }
    MessageReceiver::ProcessState TopWindow::distributeMouseMoveMessage(Point const & pointOnClient, bool bIn ){

		
        _currentMouseState->distributeAtMouseMove (*this,this->_topComponent,true ,pointOnClient,bIn); 

		

		return Processed;
    }
    MessageReceiver::ProcessState TopWindow::distributeMouseEnteredMessage(){
		
        _currentMouseState->distributeAtMouseEntered (*this,this->_topComponent,true ); 		
		

		return Processed;
    }

    MessageReceiver::ProcessState TopWindow::distributeMouseExitedMessage(){

        _currentMouseState->distributeAtMouseExited (*this, this->_topComponent,true ); 
		
		

		return Processed;
    }


	MessageReceiver::ProcessState  TopWindow::distributeCloseMessage(){

			//trace("end");

		bool const result = _topComponent->isOkToExit() ;
		if( result == true) {
			this->postDestroyRequestMessage();
			trace(" Yes");

		}else {
			trace("No");

		}


		  return Processed;
	}
        
   


	 


	void TopWindow::repaint(Rect const & rect) {
		_windowImpl->repaint(rect);		
	}

	

	
	bool const TopWindow::isCreated() const{
		return this->_windowImpl != NULL;
	}

	void  TopWindow::destroy() {

		delete _windowImpl;
		_windowImpl = NULL;

	

		this->setFocusedComponent (*Component::createNull());			
		this->_currentMouseState = MouseStateFactory::createOut();


	}

	void TopWindow::distributeEnforceDestroyMessage(){	


		assertExp(false);
		//Application::instance().unregistTopWindow(*this);		
	}





}

