/* Generated by Together */

#ifndef PODO_CHOOSEDATA_H
#define PODO_CHOOSEDATA_H

#include <set>
#include <boost/noncopyable.hpp>
#include "../../global/InnerClass.h"


#include "../Shortcut.h"
#include "../listener/ActionListener.h"
#include "../listener/ShortcutListener.h"
#include "../listener/MouseListener.h"




namespace podo{


	

	template<typename ChooseDataType>
	class ChooseTextItemMouseListener :public MouseListener {
	public:


		ChooseDataType & _listenerHaver;

		ChooseTextItemMouseListener(ChooseDataType & listenerHaver)
			: _listenerHaver(listenerHaver) {

		}
	
		// ۿ ϶ ߻ ϴ ޼          
		virtual void mousePressed(MouseListenerHaver & sender, MouseEventButtonPressed & event) {
			//trace("Click");
		}
		virtual void mouseClicked(MouseListenerHaver & sender, MouseEventButtonClicked  &event) {
			_listenerHaver.actionInvoked();
			

			
		}
		virtual void mouseDroped(MouseListenerHaver & sender, MouseEventDroped  &event) {
			//trace("Click");
		}
		//  ߻ ϴ ޼		
		virtual void mouseDraged(MouseListenerHaver & sender, MouseEventDraged  &event) {
			//trace("Click");
		}
		virtual void mouseMoved(MouseListenerHaver & sender, MouseEventMouseMoved  &event) {
			//trace("Click");
		}
		virtual void mouseExited(MouseListenerHaver & sender, MouseEventMouseExited  &event) {
			//trace("Click");
		}
		virtual void mouseEntered(MouseListenerHaver & sender, MouseEventMouseEntered  &event) {
			//trace("Click");
		}

		

	};




    template <typename ChooseView >
	class ChooseData  : public ActionListenerHaver 
		, public ShortcutListener
		,public boost::noncopyable {

	private:
		bool  _bEnabled;

	protected:
		Doc<ChooseView> _doc;
		ShortcutPtr _shortcut;

     

    public:

		ChooseData( typename Doc<ChooseView>::ViewFunc  func):_doc(func),_bEnabled(true){
		
		}

		

		virtual ~ChooseData(){	
			_shortcut.reset();		
		}



		bool const isEnable() const {
			return _bEnabled;
		}	   

		void setEnable(bool const bEnabled) {
			_bEnabled = bEnabled;

			_doc.broadcast();

		}
	
        virtual void shortcutInvoked(ShortcutListenerHaver & sender, ShortcutEvent & event)  {
			       
			actionInvoked();
		}  

		void actionInvoked() {
			if( isEnable() ) {
				ActionEventActionPerformed event;
				ActionListenerHaver::invokeActionListener(event);	            
			}
			else {
				//none;
			}	 

		}



		

		void setShortcut(Shortcut*  shortcut) {
			if(_shortcut.get() ) {
				_shortcut->setShortcutListener( ShortcutListener::createNull() );

			}
			_shortcut = ShortcutPtr(shortcut);
			_shortcut -> setShortcutListener(new ShortcutThisListener(*this));
		}

	};



	struct NormalChooseView {
		virtual void normalChooseDataChanged()  = 0;
	};


	class NormalChooseData :public ChooseData<NormalChooseView> {

	public:
		NormalChooseData():ChooseData<NormalChooseView>(&NormalChooseView::normalChooseDataChanged ) {

		}



	public:
		void registNormalChooseView(NormalChooseView & chooseView) {
			_doc.registView(chooseView);
		}
		void unregistNormalChooseView(NormalChooseView & chooseView) {
			_doc.unregistView(chooseView);
		}


	};


	
	struct CheckChooseView {
		virtual void checkChooseDataChanged()  = 0;
	};

	class CheckChooseData :public ChooseData<CheckChooseView>{
		typedef CheckChooseData super;
	 private:      
        bool _checked;
    public:

		CheckChooseData()
			:ChooseData<CheckChooseView>(&CheckChooseView::checkChooseDataChanged )
			,_checked(false){

		}


		
		virtual ~CheckChooseData(){}

      

        

		void setCheck(bool const bChecked) {
			_checked = bChecked;

			_doc.broadcast ();
		}
		
		bool const isChecked() const {

		}
		
		void registCheckChooseView(CheckChooseView & chooseView) {
			_doc.registView(chooseView);
		}
		void unregistCheckChooseView(CheckChooseView & chooseView) {
			_doc.unregistView(chooseView);
		}

       
       
    };



	class RadioChooseData;
	  class RadioGroup {

    public:

		RadioGroup(): currentCheckedData_p(NULL) {
		}

    private:
        typedef std::set < RadioChooseData * > RadioChooseDatas;
        RadioChooseDatas radioChooseDatas;

        RadioChooseData * currentCheckedData_p;
    public:
		void registRadioChooseData(RadioChooseData & radioChooseData){
			radioChooseDatas.insert(& radioChooseData);
		}
		void unregistRadioChooseData(RadioChooseData & radioChooseData){
			assertExp(!radioChooseDatas.empty());
			radioChooseDatas.erase(& radioChooseData);
		}


		bool const isCurrentChecked(RadioChooseData const & radioChooseData) const {
			return currentCheckedData_p == &radioChooseData;
		}


			
		void setCheckData(RadioChooseData & radioChooseData) {
			currentCheckedData_p = & radioChooseData;
			broadcast();			
		}

	  private:
		void broadcast() ;

      
    };

	typedef boost::shared_ptr <RadioGroup> RadioGroupPtr;
	
	  
	

	struct RadioChooseView {
		virtual void radioChooseDataChanged()  = 0;
	};

	class RadioChooseData :public ChooseData<RadioChooseView> {


		
    private: 
		/** @link aggregation */
        RadioGroupPtr radioGroup_p;

       

    public:

		RadioChooseData()
			: ChooseData<RadioChooseView>(&RadioChooseView::radioChooseDataChanged ) 
			, radioGroup_p (new RadioGroup()){
			radioGroup_p->registRadioChooseData(*this);
		}

		virtual ~RadioChooseData(){
			radioGroup_p->unregistRadioChooseData(*this);
		}

    

		bool const isChecked()const {
			radioGroup_p->isCurrentChecked(*this);
		}

		void checkChanged(){
			_doc.broadcast();
		}
		
		void setCheck() {			
            radioGroup_p->setCheckData(*this);
		}

		void registRadioChooseView(RadioChooseView & chooseView) {
			_doc.registView(chooseView);
		}
		void unregistRadioChooseView(RadioChooseView & chooseView) {
			_doc.unregistView(chooseView);
		}

    };

	typedef boost::shared_ptr <RadioChooseData> RadioChooseDataPtr;



	
	class NormalChooseDataHaver {		

		boost::shared_ptr<NormalChooseData>  _normalChooseData;
        

	protected:
		NormalChooseDataHaver()
			:_normalChooseData(new NormalChooseData) {
		}
		virtual ~NormalChooseDataHaver() {
			_normalChooseData.reset();
		}

	public:

		boost::shared_ptr<NormalChooseData> shareNormalChooseData() {
			return _normalChooseData;
		}

		//void setNormalChooseData(boost::shared_ptr<NormalChooseData> normalChooseData) {
		//	assertExp(normalChooseData.get());
		//	_normalChooseData = normalChooseData;
		//}

		NormalChooseData& accessNormalChooseData() {
			return *_normalChooseData;
		}

		NormalChooseData const & getNormalChooseData() const {
			return *_normalChooseData;
		}

	};


	class CheckChooseDataHaver {		

		boost::shared_ptr<CheckChooseData>  _checkChooseData;
        

	protected:
		CheckChooseDataHaver()
			:_checkChooseData(new CheckChooseData) {
		}
		virtual ~CheckChooseDataHaver() {
			_checkChooseData.reset();
		}

	public:

		boost::shared_ptr<CheckChooseData> shareCheckChooseData() {
			return _checkChooseData;
		}

		/*void setCheckChooseData(boost::shared_ptr<CheckChooseData> checkChooseData) {
			assertExp(checkChooseData.get());
			_checkChooseData = checkChooseData;
		}*/

		CheckChooseData& accessCheckChooseData() {
			return *_checkChooseData;
		}

		CheckChooseData const & getCheckChooseData() const {
			return *_checkChooseData;
		}

	};

	

	class RadioChooseDataHaver {		

		boost::shared_ptr<RadioChooseData>  _radioChooseData;
        

	protected:
		RadioChooseDataHaver()
			:_radioChooseData(new RadioChooseData) {
		}
		virtual ~RadioChooseDataHaver() {
			_radioChooseData.reset();
		}

	public:

		boost::shared_ptr<RadioChooseData> shareRadioChooseData() {
			return _radioChooseData;
		}

	/*	void setRadioChooseData(boost::shared_ptr<RadioChooseData> radioChooseData) {
			assertExp(radioChooseData.get());
			_radioChooseData = radioChooseData;
		}*/

		RadioChooseData& accessRadioChooseData() {
			return *_radioChooseData;
		}

		RadioChooseData const & getRadioChooseData() const {
			return *_radioChooseData;
		}

	};
}
#endif
//PODO_CHOOSEDATA_H



