#ifndef PODO_WRAPPER_COMPONENT_ENABLE_DATAHAVER_H_
#define PODO_WRAPPER_COMPONENT_ENABLE_DATAHAVER_H_

#include "../../global/InnerClass.h"

#include "EnableData.h"
#include <boost/shared_ptr.hpp>


namespace podo {

	struct EnableView {
		virtual void enableDataChanged() = 0;
	};


	class EnableData{


	private:
		bool  _bEnable;
		Doc<EnableView> _doc;


	public:

		EnableData(bool const & bEnable): _bEnable(bEnable) , _doc(&EnableView::enableDataChanged ){

		}
		EnableData(): _doc(&EnableView::enableDataChanged ), _bEnable(true){

		}
		
		
		bool const isEnable() const {

            return _bEnable;

		}
		
		void setEnable(bool const bEnable) {
			_bEnable = bEnable;
			_doc.broadcast();
		}

		void registEnableView(EnableView & enableView) {
			_doc.registView(enableView);
		}
		void unregistEnableView(EnableView & enableView) {
			_doc.unregistView(enableView);
		}

	};	

	
	class EnableDataHaver {

		boost::shared_ptr<EnableData> _enableData;        

	protected:
		EnableDataHaver() :_enableData(new EnableData(true)) {

		}

	public:

		boost::shared_ptr<EnableData> shareEnableData() {
			return _enableData;
		}		

		EnableData& accessEnableData() {
			return *_enableData;
		}

		EnableData const & getEnableData() const {
			return *_enableData;
		}
	};
}



#endif
// PODO_WRAPPER_COMPONENT_ENABLE_DATAHAVER_H_


