#ifndef _PODO_LISTDATA_H_
#define _PODO_LISTDATA_H_


#include <vector>
#include "../ChooseItem.h"
#include "../Component.h"
#include "../../global/InnerClass.h"
#include "../canvas/ChooseItemAbstractCanvas.h"



namespace podo {


	
	class ListData;

	struct ListView {
		virtual void listDataChanged(ListData const & listData) = 0;
	};


	
	
	class ListData{
		 
		struct Data {
			Data(TextItemAbstractCanvasPtr canvas,WString wstr) 
				:	 _wstr(wstr)
				,	 _canvas(canvas)	{

			}
			WString _wstr;
			TextItemAbstractCanvasPtr _canvas;
		};

		typedef std::vector<Data> Datas;
		Datas _datas;
		Doc1<ListView,ListData const &> _doc;

		 

    public:

		ListData() :_doc(&ListView::listDataChanged)	{

		}    



		void registListView(ListView & enableView) {
			_doc.registView(enableView);
		}
		void unregistListView(ListView & enableView) {
			_doc.unregistView(enableView);
		}

		void addListItem(TextItemAbstractCanvasPtr canvas  ,WString str) {
			_datas.push_back(Data(canvas,  str));
			_doc.broadcast(*this);
		}

		size_t const size() const {
			return _datas.size();

		}

		ComponentPtr at(size_t const  index ) const {
			Component * result =new  TextItem(_datas[index]._canvas, _datas[index]._wstr);
			return ComponentPtr(result);

		}
	

		

	};


	class ListDataHaver {

		boost::shared_ptr<ListData> _listData;        

	protected:
		ListDataHaver() :_listData(new ListData()) {

		}

		boost::shared_ptr<ListData> shareListData() {
			return _listData;
		}		

		ListData& accessListData() {
			return *_listData;
		}

		ListData const & getListData() const {
			return *_listData;
		}



	};


}


#endif
// _PODO_LISTDATA_H_


