#ifndef PODO_WRAPPER_COMPONENTWSTRINGDATA_H_
#define PODO_WRAPPER_COMPONENTWSTRINGDATA_H_

#include "../../global/String.h"
#include "../../global/InnerClass.h"

#include <boost/noncopyable.hpp>
#include <boost/shared_ptr.hpp>

namespace podo {

	struct WStringView {

		virtual void wstringDataChanged()  = 0;

	};

	class WStringData{

		Doc<WStringView> _doc;


	private:
		WString _text;

	public:

		WStringData(WString const & wstr): _text(wstr),_doc(&WStringView::wstringDataChanged ){

		}

		WStringData(): _text(L""),_doc(&WStringView::wstringDataChanged ){

		}


		void setWString(WString const & wstr) {

			  _text = wstr ;
			  _doc.broadcast();
		}

		void registWStringView(WStringView & wstringView) {
			_doc.registView(wstringView);

		}

		void unregistWStringView(WStringView & wstringView) {
			_doc.unregistView(wstringView);

		}



			

		WString &access() {
			// Component repaint ȣ ϰ ȴ.. repaint ۸ ȴ..
			//׷ ȿ  ֱ  ߿  Ŭ Ϻϰ  ʿ䰡 ִ.
			//̰  canvasο ȣ ϸ  ȴ..
			_doc.broadcast();
			return _text;

		}

		WString  const &get()const  {
			// Component repaint ȣ ϰ ȴ.. repaint ۸ ȴ..
			//׷ ȿ  ֱ  ߿  Ŭ Ϻϰ  ʿ䰡 ִ.
			//̰  canvasο ȣ ϸ  ȴ..
			//broadcast();
			return _text;

		}


		//ؿ κ Data ġµ  ǰ ϰ,( Ѵ.)
		//
		// ϴµ Ǽ ش..(begin(), end() iterator    ִ.)


		/*class WStringAccessorImpl {
			WString * _wstr;
			WStringData * _data;


			WStringAccessor(WString & wstr,WStringData & data)
				:_wstr(&wstr),_data(&data) {

                

			}

			WStringAccessor() {
				data->broadcast();
			}	



		};

		class WStringAccessor {
		public:

			boost::shared_ptr<WStringAccessorImpl> _impl;
            		
			

					

		};*/

	};	



	



	class WStringDataHaver {	

		boost::shared_ptr<WStringData>  _data;
	protected:
		WStringDataHaver() :_data(new WStringData()){

		}

		


	public:
	

		boost::shared_ptr<WStringData> shareWStringData() {
			return _data;
		}

		

		WStringData& accessWStringData() {
			return  * _data;
		}

		WStringData const & getWStringData() const {
			return *_data ;
		}


	};


}



#endif
//PODO_WRAPPER_COMPONENTWSTRINGDATA_H_


