/* Generated by Together */

#include "LanguageSystem.h"
#include "english/EnglishSystem.h"
#include "hangul/HangulSystem.h"
#include "../../global/KeyboardKey.h"
#include "LanguageInputTranslator.h"


namespace podo{


		void ReceivableBroadcaster::setString(wchar_t const ch, bool const & bCompositeState) {
			Receivables::iterator iterbegin = receivables.begin();
			Receivables::iterator iterend = receivables.end();


			Receivables::iterator iter;

			for (iter = iterbegin; iter != iterend; ++iter) {

				(*iter)->setString(ch,bCompositeState);

			}
		}

		void ReceivableBroadcaster::addString(wchar_t const ch, bool const & bCompositeState) {
			Receivables::iterator iterbegin = receivables.begin();
			Receivables::iterator iterend = receivables.end();


			Receivables::iterator iter;

			for (iter = iterbegin; iter != iterend; ++iter) {

				(*iter)->addString(ch,bCompositeState);

			}

		}

		void ReceivableBroadcaster::subString( bool const & bCompositeState) {
			Receivables::iterator iterbegin = receivables.begin();
			Receivables::iterator iterend = receivables.end();


			Receivables::iterator iter;

			for (iter = iterbegin; iter != iterend; ++iter) {

				(*iter)->subString(bCompositeState);

			}

		}

		
		void ReceivableBroadcaster::addReceivable(Receivable & re_r) {
			assertExp(receivables.find(& re_r) == receivables.end());
			receivables.insert(& re_r);
		}

		void ReceivableBroadcaster::subReceivable(Receivable & re_r) {
			assertExp(receivables.find(& re_r) != receivables.end());
			receivables.erase(& re_r);
		}

		bool ReceivableBroadcaster::hasReceivable(Receivable & re_r) {
			return receivables.find(& re_r) != receivables.end();
		}



	

		LanguageSystem::Language LanguageSystem::getCurrentLanguage() const {
			return convertable_p->getCurrentLanguage();
		}

		void LanguageSystem::changeToEnglish() {
			convertable_p->inputReset();
			delete convertable_p;
			convertable_p = new EnglishSystem(this->_receivableBroadcaster );
		}

		void LanguageSystem::changeToHangul() {
			convertable_p->inputReset();
			delete convertable_p;
			convertable_p = new HangulSystem(this->_receivableBroadcaster );
		}

	

	

		LanguageSystem & LanguageSystem::instance() {
			static LanguageSystem instance;

			return instance;
		}

		LanguageSystem::LanguageSystem() : convertable_p(0) {

			convertable_p = new EnglishSystem(this->_receivableBroadcaster );

		}

		void LanguageSystem::inputReset() {
			assertExp(convertable_p);
			convertable_p->inputReset();
		}

		void LanguageSystem::input(KeyboardKey const & key) {
			assertExp(convertable_p);
			convertable_p->input(key);
		}
	

}


