


#include "CharactorUtil.h"
#include "Jaum.h"
#include "Moum.h"
#include "HangulCode.h"


namespace podo{
	

			bool const CharactorUtil::isCanJongsung(JaumPtr jaum) {
				wchar_t testCh = jaum->ch;
				return  ( testCh == HANGUL_KIYEOK ) || ( testCh == HANGUL_SSANGKIYEOK ) || ( testCh == HANGUL_NIEUN )|| ( testCh == HANGUL_TIKEUT )||
					( testCh == HANGUL_RIEUL )|| ( testCh == HANGUL_MIEUM )|| ( testCh == HANGUL_PIEUP )|| ( testCh == HANGUL_SIOS )|| 
					( testCh == HANGUL_SSANGSIOS )|| ( testCh == HANGUL_IEUNG )|| ( testCh == HANGUL_CIEUC )|| ( testCh == HANGUL_CHIEUCH )||
					( testCh == HANGUL_THIEUTH )|| ( testCh == HANGUL_PHIEUPH )|| ( testCh == HANGUL_HIEUH );

			}

			bool const CharactorUtil::isCanComposite(JaumPtr jaum1, JaumPtr jaum2) {
				if(!isCanJongsung(jaum1)){
					return false;
				}
				if(!isCanJongsung(jaum2)){
					return false;
				}				

				wchar_t ch = composite(jaum1, jaum2) ;

				if(ch == ' ') {
					return false;
				}

				return true;
				

			}
			bool const CharactorUtil::isCanComposite(MoumPtr moum1, MoumPtr moum2) {

				wchar_t ch = composite(moum1, moum2) ;

				if(ch == ' ') {
					return false;
				}

				return true;

			}

			wchar_t const CharactorUtil::composite(JaumPtr jaum1, JaumPtr jaum2) {

				wchar_t ch = jaum1->ch;
				wchar_t ch2 = jaum2->ch;

				
				if(ch == HANGUL_KIYEOK && ch2 == HANGUL_SIOS) {
					return HANGUL_KIYEOK_SIOS;
				} 

				if(ch == HANGUL_NIEUN && ch2 == HANGUL_CIEUC) {
					return HANGUL_NIEUN_CIEUC;
				} 

				if(ch == HANGUL_NIEUN && ch2 == HANGUL_HIEUH) {
					return HANGUL_NIEUN_HIEUH;
				} 

				if(ch == HANGUL_RIEUL && ch2 == HANGUL_KIYEOK) {
					return HANGUL_RIEUL_KIYEOK;
				} 

				if(ch == HANGUL_RIEUL && ch2 == HANGUL_MIEUM) {
					return HANGUL_RIEUL_MIEUM;
				} 

				if(ch == HANGUL_RIEUL && ch2 == HANGUL_PIEUP) {
					return HANGUL_RIEUL_PIEUP;
				}

				if(ch == HANGUL_RIEUL && ch2 == HANGUL_SIOS) {
					return HANGUL_RIEUL_SIOS;
				} 

				if(ch == HANGUL_RIEUL && ch2 == HANGUL_THIEUTH) {
					return HANGUL_RIEUL_THIEUTH;
				} 


				if(ch == HANGUL_RIEUL && ch2 == HANGUL_PHIEUPH) {
					return HANGUL_RIEUL_PHIEUPH;
				} 


				if(ch == HANGUL_RIEUL && ch2 == HANGUL_HIEUH) {
					return HANGUL_RIEUL_HIEUH;
				} 

				if(ch == HANGUL_PIEUP && ch2 == HANGUL_SIOS) {
					return HANGUL_PIEUP_SIOS;
				}

				if(ch == HANGUL_O && ch2 == HANGUL_A) {
					return HANGUL_WA;
				} 

				if(ch == HANGUL_O && ch2 == HANGUL_AE) {
					return HANGUL_WAE;
				} 

				if(ch == HANGUL_O && ch2 == HANGUL_I) {
					return HANGUL_OE;
				} 

				if(ch == HANGUL_U && ch2 == HANGUL_EO) {
					return HANGUL_WEO;
				} 

				if(ch == HANGUL_U && ch2 == HANGUL_E) {
					return HANGUL_WE;
				} 

				if(ch == HANGUL_U && ch2 == HANGUL_I) {
					return HANGUL_WI;
				} 

				if(ch == HANGUL_EU && ch2 == HANGUL_I) {
					return HANGUL_YI;

				} 

				return ' ';

			}

			wchar_t const CharactorUtil::composite(MoumPtr moum1, MoumPtr moum2) {

				wchar_t ch = moum1->ch;
				wchar_t ch2 = moum2->ch;

				
				

				if(ch == HANGUL_O && ch2 == HANGUL_A) {
					return HANGUL_WA;
				} 

				if(ch == HANGUL_O && ch2 == HANGUL_AE) {
					return HANGUL_WAE;
				} 

				if(ch == HANGUL_O && ch2 == HANGUL_I) {
					return HANGUL_OE;
				}

				if(ch == HANGUL_U && ch2 == HANGUL_EO) {
					return HANGUL_WEO;
				} 

				if(ch == HANGUL_U && ch2 == HANGUL_E) {
					return HANGUL_WE;
				} 

				if(ch == HANGUL_U && ch2 == HANGUL_I) {
					return HANGUL_WI;
				} 

				if(ch == HANGUL_EU && ch2 == HANGUL_I) {
					return HANGUL_YI;

				} 

				return ' ';

			}

			

			uint16_t const CharactorUtil::changeToChosungCode(JaumPtr jaum) {

				wchar_t chH = jaum->ch;

				switch (chH) {
                    case HANGUL_KIYEOK:
                        return 0;
                    case HANGUL_SSANGKIYEOK:
                        return 1;
                    case HANGUL_NIEUN:
                        return 2;
                    case HANGUL_TIKEUT:
                        return 3;
                    case HANGUL_SSANGTIKEUT:
                        return 4;
                    case HANGUL_RIEUL:
                        return 5;
                    case HANGUL_MIEUM:
                        return 6;
                    case HANGUL_PIEUP:
                        return 7;
                    case HANGUL_SSANGPIEUP:
                        return 8;
                    case HANGUL_SIOS:
                        return 9;
                    case HANGUL_SSANGSIOS:
                        return 10;
                    case HANGUL_IEUNG:
                        return 11;
                    case HANGUL_CIEUC:
                        return 12;
                    case HANGUL_SSANGCIEUC:
                        return 13;
                    case HANGUL_CHIEUCH:
                        return 14;
                    case HANGUL_KHIEUKH:
                        return 15;
                    case HANGUL_THIEUTH:
                        return 16;
                    case HANGUL_PHIEUPH:
                        return 17;
                    case HANGUL_HIEUH:
                        return 18;
                    default:
						assertExp(false);
                        return 0;
                }


			}				

			uint16_t const CharactorUtil::changeToJungsungCode(MoumPtr moum) {


				wchar_t chM = moum->ch;


				if (chM == HANGUL_A ) {
                    return 0;
                }

                if (chM == HANGUL_AE ) {
                    return 1;
                }

                if (chM == HANGUL_YA ) {
                    return 2;
                }

                if (chM == HANGUL_YAE ) {
                    return 3;
                }

                if (chM == HANGUL_EO ) {
                    return 4;
                }

                if (chM == HANGUL_E ) {
                    return 5;
                }

                if (chM == HANGUL_YEO ) {
                    return 6;
                }

				if (chM == HANGUL_YE ) {
                    return 7;
                }
                if (chM == HANGUL_O ) {
                    return 8;
                }
                


                if (chM == HANGUL_YO ) {
                    return 12;
                }

                if (chM == HANGUL_U ) {
                    return 13;
                }

                

                if (chM == HANGUL_YU ) {
                    return 17;
                }
                if (chM == HANGUL_EU ) {
                    return 18;
                }
                

                if (chM == HANGUL_I ) {
                    return 20;
                }

                

				return 0;

			}

			uint16_t const CharactorUtil::changeToJungsungCode(MoumPtr moum1, MoumPtr moum2) {
				wchar_t chM = moum1->ch;
				wchar_t chM2 = moum2->ch;

				if (chM == HANGUL_O && chM2 == HANGUL_A) {
                    return 9;
                }

                if (chM == HANGUL_O && chM2 == HANGUL_AE) {
                    return 10;
                }

                if (chM == HANGUL_O && chM2 == HANGUL_I) {
                    return 11;
                }
				if (chM == HANGUL_U && chM2 == HANGUL_EO) {
                    return 14;
                }

                if (chM == HANGUL_U && chM2 == HANGUL_E) {
                    return 15;
                }

                if (chM == HANGUL_U && chM2 == HANGUL_I) {
                    return 16;
                }

				if (chM == HANGUL_EU && chM2 == HANGUL_I) {
                    return 19;
                }

				return 0;

			}

			uint16_t const CharactorUtil::changeToJongsungCode(JaumPtr jaum) {

				/* if (chL == ' ' && chL2 == ' ') {
                    return 0;
                }*/

				wchar_t chL = jaum->ch;

                if (chL == HANGUL_KIYEOK ) {
                    return 1;
                }

                if (chL == HANGUL_SSANGKIYEOK  ) {
                    return 2;
                }                  

                if (chL == HANGUL_NIEUN ) {
                    return 4;
                }

                if (chL == HANGUL_TIKEUT ) {
                    return 7;
                }
                if (chL == HANGUL_RIEUL ) {
                    return 8;
                }
                
                
                if (chL == HANGUL_MIEUM  ) {
                    return 16;
                }

                if (chL == HANGUL_PIEUP ) {
                    return 17;
                }
                
                if (chL == HANGUL_SIOS ) {
                    return 19;
                }

                if (chL == HANGUL_SSANGSIOS ) {
                    return 20;
                }

                if (chL == HANGUL_IEUNG ) {
                    return 21;
                }
                if (chL == HANGUL_CIEUC ) {
                    return 22;
                }

                if (chL == HANGUL_CHIEUCH ) {
                    return 23;
                }

                if (chL == HANGUL_KHIEUKH ) {
                    return 24;
                }

                if (chL == HANGUL_THIEUTH ) {
                    return 25;
                }

                if (chL == HANGUL_PHIEUPH ) {
                    return 26;
                }

                if (chL == HANGUL_HIEUH ) {
                    return 27;
                }


                

                return 0;

			}

			uint16_t const CharactorUtil::changeToJongsungCode(JaumPtr jaum1, JaumPtr jaum2) {


				wchar_t chL = jaum1->ch;
				wchar_t chL2 = jaum2->ch;


				if (chL == HANGUL_KIYEOK && chL2 == HANGUL_SIOS) {
                    return 3;
                }
                if (chL == HANGUL_NIEUN && chL2 == HANGUL_CIEUC) {
                    return 5;
                }

                if (chL == HANGUL_NIEUN && chL2 == HANGUL_HIEUH) {
                    return 6;
                }
					if (chL == HANGUL_RIEUL && chL2 == HANGUL_KIYEOK) {
                    return 9;
                }

					if (chL == HANGUL_RIEUL && chL2 == HANGUL_MIEUM) {
                    return 10;
                }

                if (chL == HANGUL_RIEUL && chL2 == HANGUL_PIEUP) {
                    return 11;
                }
                if (chL == HANGUL_RIEUL && chL2 == HANGUL_SIOS) {
                    return 12;
                }

                if (chL == HANGUL_RIEUL && chL2 == HANGUL_THIEUTH) {
                    return 13;
                }

                if (chL == HANGUL_RIEUL && chL2 == HANGUL_PHIEUPH) {
                    return 14;
                }

                if (chL == HANGUL_RIEUL && chL2 == HANGUL_HIEUH) {
                    return 15;
                }

					if (chL == HANGUL_PIEUP && chL2 == HANGUL_SIOS) {
                    return 18;
                }

					return 0;

			}

			wchar_t CharactorUtil::compositeAll(uint16_t chosungCode, uint16_t jungsungCode, uint16_t jongsungCode ) {

				int const HANGUL_OFFSET = 0xAC00;
				int const JONGSUNG = 1;				
				int const JUNGSUNG = 28;
				int const CHOSUNG = 21 * 28;

			
						
				int result = HANGUL_OFFSET +
				chosungCode * CHOSUNG + 
				jungsungCode * JUNGSUNG + 
				jongsungCode * JONGSUNG;

				assertExp(0xAC00<= result);
				assertExp(result <= 0xD7AF);

				return static_cast<wchar_t>(result);


                
			}

			
			
		
}

