/* Generated by Together */

#include "HangulSystem.h"





#include "HangulCode.h"

#include "Jaum.h"
#include "Moum.h"
#include "Other.h"
#include "Backspace.h"
#include "Ignore.h"
#include "Reset.h"
#include "State.h"

#include "../../../global/KeyboardKey.h"


namespace podo{
	



			Token * HangulSystem::createToken(KeyboardKey const & key) { 

				switch(key.getVirtualKey ()) {
					case KeyboardKey::VIRTUAL_0:
						return new Other(key.getShift()?')':'0');
						
					case KeyboardKey::VIRTUAL_1:
						return new Other(key.getShift()?'!':'1');
						
					case KeyboardKey::VIRTUAL_2:
						return new Other(key.getShift()?'@':'2');
			
					case KeyboardKey::VIRTUAL_3:
						return new Other(key.getShift()?'#':'3');
			
					case KeyboardKey::VIRTUAL_4:
						return new Other(key.getShift()?'$':'4');
	
					case KeyboardKey::VIRTUAL_5:
						return new Other(key.getShift()?'%':'5');
		

					case KeyboardKey::VIRTUAL_6:
						return new Other(key.getShift()?'^':'6');
				
					case KeyboardKey::VIRTUAL_7:
						return new Other(key.getShift()?'&':'7');
			

					case KeyboardKey::VIRTUAL_8:
						return new Other(key.getShift()?'*':'8');
						
					case KeyboardKey::VIRTUAL_9:
						return new Other(key.getShift()?'(':'9');
						
						
					case key.VIRTUAL_A :
						return new Jaum(HANGUL_MIEUM);
					case key.VIRTUAL_B :
						return new Moum(HANGUL_YU);
					case key.VIRTUAL_C :
						return new Jaum(HANGUL_CHIEUCH);
					case key.VIRTUAL_D :
						return new Jaum(HANGUL_IEUNG);
					case key.VIRTUAL_E :
						if(key.getShift() ) {
							return new Jaum(HANGUL_SSANGTIKEUT);
						}else {
							return new Jaum(HANGUL_TIKEUT);
						}
					case key.VIRTUAL_F :
						return new Jaum(HANGUL_RIEUL);
					case key.VIRTUAL_G :
						return new Jaum(HANGUL_HIEUH);
					case key.VIRTUAL_H :
						return new Moum(HANGUL_O);
					case key.VIRTUAL_I :
						return new Moum(HANGUL_YA);
					case key.VIRTUAL_J :
						return new Moum(HANGUL_EO);
					case key.VIRTUAL_K :
						return new Moum(HANGUL_A);
					case key.VIRTUAL_L :
						return new Moum(HANGUL_I);
					case key.VIRTUAL_M :
						return new Moum(HANGUL_EU);
					case key.VIRTUAL_N :
						return new Moum(HANGUL_U);
					case key.VIRTUAL_O :
						return new Moum(HANGUL_AE);
					case key.VIRTUAL_P :
						return new Moum(HANGUL_E);
					case key.VIRTUAL_Q :
						if(key.getShift() ) {
							return new Jaum(HANGUL_SSANGPIEUP);
						}else {
							return new Jaum(HANGUL_PIEUP);
						}
					case key.VIRTUAL_R :
						if(key.getShift() ) {
							return new Jaum(HANGUL_SSANGKIYEOK);
						}else {
							return new Jaum(HANGUL_KIYEOK);
						}
					case key.VIRTUAL_S :						
						return new Jaum(HANGUL_NIEUN);
					case key.VIRTUAL_T :
						if(key.getShift() ) {
							return new Jaum(HANGUL_SSANGSIOS);
						}else {
							return new Jaum(HANGUL_SIOS);
						}
					case key.VIRTUAL_U :
						return new Moum(HANGUL_YEO);
					case key.VIRTUAL_V :
						return new Jaum(HANGUL_PHIEUPH);
					case key.VIRTUAL_W :
						if(key.getShift() ) {
							return new Jaum(HANGUL_SSANGCIEUC);
						}else {
							return new Jaum(HANGUL_CIEUC);
						}
					case key.VIRTUAL_X :
						return new Jaum(HANGUL_THIEUTH);
					case key.VIRTUAL_Y :
						return new Moum(HANGUL_YO);
					case key.VIRTUAL_Z :
						return new Jaum(HANGUL_KHIEUKH);

					case key.VIRTUAL_BACKSPACE:
						return new Backspace();
					case key.VIRTUAL_SPACE :
						return new Other(' ');
					case key.VIRTUAL_TAB :
						return new Other('\t');
					default:
						return new Ignore();
				}

			}

			void HangulSystem::input(KeyboardKey const & key) {

				Token * token_p = this->createToken(key);;

			
				assertExp(_currentStack.size() > 0);
				token_p->excuteState (this->_currentStack,this->_receivable ,_currentStack.accessTop() );
				
				delete token_p;


			}


			void HangulSystem::inputReset() {
				Token * token  = new Reset();
				token->excuteState(this->_currentStack,this->_receivable ,_currentStack.accessTop() );
				delete token;			

			}


		

}


