/* Generated by Together */

#ifndef CHARACTORLISTENER_H
#define CHARACTORLISTENER_H

#include "ListenerHaver.h"


namespace podo{
 


	class CharactorEvent {
		protected:
			bool _bCompositeState;
		public:
			CharactorEvent(bool const &bCompositeState):
				_bCompositeState(bCompositeState){


			}
		
	};

	class CharactorEventSubString : public CharactorEvent {
		        

	public:        

		CharactorEventSubString(bool const &bCompositeState):CharactorEvent(bCompositeState){
		}

		
	};


	class CharactorEventAddString : public CharactorEvent {
	public:        

			CharactorEventAddString(wchar_t const & initCh,bool const &bCompositeState) 
				:_ch(initCh),CharactorEvent(bCompositeState) {
			}
			wchar_t const _ch;        
	};

	
	class CharactorEventSetString : public CharactorEvent {
	public:        

		CharactorEventSetString(wchar_t const &initCh,bool const &bCompositeState)
			:ch(initCh),CharactorEvent(bCompositeState){		
		}
		wchar_t const ch;       		
	};


	class CharactorListenerHaver;

	class CharactorListener;
	typedef boost::shared_ptr<CharactorListener> CharactorListenerPtr;
	class CharactorListener {


	public:

		~CharactorListener();


		virtual void setString(CharactorListenerHaver &sender, CharactorEventSetString & event) = 0;
		virtual void addString(CharactorListenerHaver &sender, CharactorEventAddString & event) = 0;
		virtual void subString(CharactorListenerHaver &sender, CharactorEventSubString & event) = 0;


		static CharactorListenerPtr createNull () ;
		
	};

	class CharactorAdapter : public CharactorListener {
		virtual void setString(CharactorListenerHaver &sender, CharactorEventSetString & event) {}
		virtual void addString(CharactorListenerHaver &sender, CharactorEventAddString & event) {}
		virtual void subString(CharactorListenerHaver &sender, CharactorEventSubString & event) {}
	};


	
	//template <typename THIS_LISTENER>
	class CharactorThisListener :public CharactorListener {

	private:
		CharactorListener & _this;
	public:

		virtual ~CharactorThisListener(){

		}
		CharactorThisListener(CharactorListener& thislistener) :_this(thislistener){

		}

		virtual void setString(CharactorListenerHaver &sender, CharactorEventSetString & event) {
			_this.setString(sender,event);
		}
		virtual void addString(CharactorListenerHaver &sender, CharactorEventAddString & event) {
			_this.addString(sender,event);

		}
		virtual void subString(CharactorListenerHaver &sender, CharactorEventSubString & event) {
			_this.subString(sender,event);
		}			
		
	};

	class CharactorMacroListener : public CharactorListener {

		CharactorListenerPtr _before;
		CharactorListenerPtr _after;
	public:

		CharactorMacroListener(CharactorListenerPtr before, CharactorListenerPtr after) : _before(before), _after(after) {

		                                    
		}

		virtual void setString(CharactorListenerHaver &sender, CharactorEventSetString & event) {
			_before	->setString(sender,event);
			_after	->setString(sender,event);
		}

		virtual void addString(CharactorListenerHaver &sender, CharactorEventAddString & event) {
			_before	->addString(sender,event);
			_after	->addString(sender,event);
		}

		virtual void subString(CharactorListenerHaver &sender, CharactorEventSubString & event) {
			_before	->subString(sender,event);
			_after	->subString(sender,event);
		}		

	};


	
    class CharactorListenerHaver {


	

    private:
        ListenerHaver < CharactorListener,CharactorMacroListener > _listenerHaver;
  

	public:

		CharactorListenerHaver() {

		}

		

        void setCharactorListener(CharactorListener* charactorListener) {
            _listenerHaver.setListener(charactorListener);
        }

        void setCharactorListener(CharactorListenerPtr charactorListener) {
            _listenerHaver.setListener(charactorListener);
        }

        void addCharactorListener(CharactorListener * charactorListener) {
            _listenerHaver.addListener(charactorListener);
        }

        void addCharactorListener(CharactorListenerPtr charactorListener) {
            _listenerHaver.addListener(charactorListener);
        }

       

		void invokeCharactorListener(CharactorEventAddString & event) {
			
			typedef CharactorListener TT_Listener;
			typedef CharactorListenerHaver TT_ListenerHaver;
			typedef CharactorEventAddString TT_Event;


			typedef void ( TT_Listener::*Func)(TT_ListenerHaver &, TT_Event  &);
			_listenerHaver.invokeListener<Func,TT_ListenerHaver &, TT_Event &>(&TT_Listener::addString ,*this,event);
		}

		void invokeCharactorListener(CharactorEventSubString & event) {
			
			typedef CharactorListener TT_Listener;
			typedef CharactorListenerHaver TT_ListenerHaver;
			typedef CharactorEventSubString TT_Event;


			typedef void ( TT_Listener::*Func)(TT_ListenerHaver &, TT_Event  &);
			_listenerHaver.invokeListener<Func,TT_ListenerHaver &, TT_Event &>(&TT_Listener::subString ,*this,event);
		}
		void invokeCharactorListener(CharactorEventSetString & event) {
			
			typedef CharactorListener TT_Listener;
			typedef CharactorListenerHaver TT_ListenerHaver;
			typedef CharactorEventSetString TT_Event;


			typedef void ( TT_Listener::*Func)(TT_ListenerHaver &, TT_Event  &);
			_listenerHaver.invokeListener<Func,TT_ListenerHaver &, TT_Event &>(&TT_Listener::setString ,*this,event);
		}
		      

		virtual ~CharactorListenerHaver () {

		}

  
    };

}



#endif
//CHARACTORLISTENER_H
