/* Generated by Together */

#ifndef LISTENER_FOCUSLISTENER_H
#define LISTENER_FOCUSLISTENER_H
//

#include "ListenerHaver.h"



namespace podo{
 
	class FocusEvent {};

	
	class FocusEventFocusGained : public FocusEvent { };

	class FocusEventFocusLost : public FocusEvent { };

	class FocusListenerHaver;
	class FocusListener;
	typedef boost::shared_ptr<FocusListener> FocusListenerPtr;
	class FocusListener {
		public:
		virtual ~FocusListener(){}

		virtual void focusGained(FocusListenerHaver & sender , FocusEventFocusGained  &event) = 0;
		virtual void focusLost(FocusListenerHaver & sender ,FocusEventFocusLost  &event) = 0;

		static FocusListenerPtr createNull();


	};

		
	class FocusAdapter : public FocusListener {
		virtual void focusGained(FocusListenerHaver & sender , FocusEventFocusGained  &event) {}
		virtual void focusLost(FocusListenerHaver & sender ,FocusEventFocusLost  &event) {}
	};


	class FocusThisListener : public FocusListener {
		        

		FocusListener & _this;
		
	public:

		FocusThisListener(FocusListener & this_r):_this(this_r){			                        
		}

		virtual void focusGained(FocusListenerHaver & sender , FocusEventFocusGained  &event) {
			_this.focusGained(sender,event);			
		}

		virtual void focusLost(FocusListenerHaver & sender ,FocusEventFocusLost  &event) {			
			_this.focusLost(sender,event);		
		}
	};

	class FocusMacroListener : public FocusListener {
		        

		FocusListenerPtr _before;
		FocusListenerPtr _after;
	public:

		FocusMacroListener(FocusListenerPtr before, FocusListenerPtr after) : _before(before), _after(after) {

			                        
		}

		virtual void focusGained(FocusListenerHaver & sender , FocusEventFocusGained  &event) {
			_before->focusGained(sender,event);
			_after->focusGained(sender,event);		
		}
		virtual void focusLost(FocusListenerHaver & sender ,FocusEventFocusLost  &event) {
			_before->focusLost(sender,event);
			_after->focusLost(sender,event);		
		}
	};



	class FocusListenerHaver {
		private:        
			ListenerHaver<FocusListener,FocusMacroListener > _listenerHaver;


		public:


			void setFocusListener(FocusListener* focusListener) {
				_listenerHaver.setListener(focusListener);
			}

		    
			void addFocusListener(FocusListener* focusListener) {
				_listenerHaver.addListener(focusListener);
			}

			void setFocusListener(FocusListenerPtr focusListener) {
				_listenerHaver.setListener(focusListener);
			}
		    
			void addFocusListener(FocusListenerPtr focusListener) {
				_listenerHaver.addListener(focusListener);
			}
			


			void invokeFocusListener(FocusEventFocusGained  &event) {
				typedef FocusListener TT_Listener;
				typedef FocusListenerHaver TT_ListenerHaver;
				typedef FocusEventFocusGained TT_Event;


				typedef void ( TT_Listener::*Func)(TT_ListenerHaver &, TT_Event  &);
				_listenerHaver.invokeListener<Func,TT_ListenerHaver &, TT_Event &>(&TT_Listener::focusGained ,*this,event);


			}

			void invokeFocusListener(FocusEventFocusLost  &event) {
				typedef FocusListener TT_Listener;
				typedef FocusListenerHaver TT_ListenerHaver;
				typedef FocusEventFocusLost TT_Event;


				typedef void ( TT_Listener::*Func)(TT_ListenerHaver &, TT_Event  &);
				_listenerHaver.invokeListener<Func,TT_ListenerHaver &, TT_Event &>(&TT_Listener::focusLost ,*this,event);

			}




			virtual ~FocusListenerHaver () {		}
			
	   
	};
}




#endif
//LISTENER_FOCUSLISTENER_H
