
#ifndef GETDRAGDATALISTENER_H
#define GETDRAGDATALISTENER_H




#include "../event/PropertyOldPoint.h"
#include "../event/PropertyCurrentPoint.h"
#include "../event/PropertyDragStarted.h"
#include "../event/PropertyPointDragStarted.h"


#include "../Component.p"
#include "../system/DragData.p"
#include "../../global/Point.h"
#include "../../global/MouseButton.h"

#include "ListenerHaver.h"

namespace podo{


    




	class GetDragDataEvent  {

	public:
		DragDataPtr _dragData;
	
	private: 
		MouseButton const _mouseButtonDragStarted;
	        

	public:        

		GetDragDataEvent(MouseButton buttonDragStarted )
			:  _mouseButtonDragStarted(buttonDragStarted){


		}

			

		DragDataPtr getDragData() {

			return _dragData;

		}


	};




	class GetDragDataListenerHaver;

 
	class GetDragDataListener;
	typedef boost::shared_ptr<GetDragDataListener> GetDragDataListenerPtr;
	class GetDragDataListener {
		public:		
		

		virtual DragDataPtr getDragData(GetDragDataListenerHaver & sender,GetDragDataEvent & event) = 0;

		static GetDragDataListenerPtr createNull();

//end Func
	};


	class GetDragDataAdapter :public GetDragDataListener{
		virtual DragDataPtr getDragData(GetDragDataListenerHaver & sender,GetDragDataEvent & event) {
			return DragDataPtr();
		}
	};

	

		//template <typename THIS_LISTENER>
		class GetDragDataThisListener :public GetDragDataListener {

		private:
			GetDragDataListener & _this;
		public:

			virtual ~GetDragDataThisListener(){

			}
			GetDragDataThisListener(GetDragDataListener& thislistener) :_this(thislistener){

			}
			
			
			virtual DragDataPtr getDragData(GetDragDataListenerHaver & sender,GetDragDataEvent & event){
				return _this.getDragData(sender,event);
			
			}
		};



		  class GetDragDataListenerHaver {

	private:        
			

			GetDragDataListenerPtr _listener ;

		public:

			Enable* _enable;

	public:

		

			GetDragDataListenerHaver() {
				_listener = GetDragDataListener::createNull();



			}

			void registEnable(Enable & enable) {
				_enable = &enable;
			}


			void setGetDragDataListener(GetDragDataListener* mouseListener) {
				_listener.reset(mouseListener);				
			}	    
			

			void setGetDragDataListener(GetDragDataListenerPtr mouseListener) {
				_listener = mouseListener;
			}
			

			GetDragDataListenerPtr shareGetDragDataListener() {
				return _listener;
			}

			void invokeGetDragDataListener(GetDragDataEvent &event) {
				

				DragDataPtr result = _listener->getDragData(*this,event);
				event._dragData = result;

			}



			virtual ~GetDragDataListenerHaver () {		}

  
    };



}



#endif
//GETDRAGDATALISTENER_H


