/* Generated by Together */

#ifndef LISTENER_KEYLISTENER_H
#define LISTENER_KEYLISTENER_H
//

#include "../../global/KeyboardKey.h"
#include "ListenerHaver.h"




namespace podo{


	class KeyEvent {
		

	protected:    
		KeyboardKey _key;
		
	public:

		KeyEvent(KeyboardKey const &initKey):_key(initKey) {
		}		

		KeyboardKey const &getKey() const {

			return _key;
		}

		virtual ~KeyEvent() {
		}
	};


			
	class KeyEventKeyPressed : public KeyEvent {
	public:

		KeyEventKeyPressed(KeyboardKey const &initKey):KeyEvent(initKey){
		}

	     
	};


	class KeyEventKeyReleased : public KeyEvent {
	public:

		KeyEventKeyReleased(KeyboardKey const &initKey):KeyEvent(initKey){}   
	};

 

	class KeyListenerHaver;

	class KeyListener;
	typedef boost::shared_ptr<KeyListener> KeyListenerPtr;
	class KeyListener {
		public:

			virtual ~KeyListener(){}

			virtual void keyReleased(KeyListenerHaver &sender, KeyEventKeyReleased &event ) = 0;
			virtual void keyPressed(KeyListenerHaver &sender,KeyEventKeyPressed & event) = 0;

			static KeyListenerPtr createNull();
	};

		

	class KeyAdapter : public KeyListener {

		virtual void keyReleased(KeyListenerHaver &sender, KeyEventKeyReleased &event ) {}
		virtual void keyPressed(KeyListenerHaver &sender,KeyEventKeyPressed & event) {}
	};

	class KeyThisListener : public KeyListener {
		        

		KeyListener&  _this;
		
	public:

		KeyThisListener(KeyListener&  this_r) :_this(this_r) { }

		virtual void keyReleased(KeyListenerHaver &sender, KeyEventKeyReleased &event ) {
			_this.keyReleased(sender,event);		
		}
		virtual void keyPressed(KeyListenerHaver &sender,KeyEventKeyPressed & event) {
			_this.keyPressed(sender,event);		
		}
	};

	class KeyMacroListener : public KeyListener {
		        

		KeyListenerPtr _before;
		KeyListenerPtr _after;
	public:

		KeyMacroListener(KeyListenerPtr before, KeyListenerPtr after) : _before(before), _after(after) { }

		virtual void keyReleased(KeyListenerHaver &sender, KeyEventKeyReleased &event ) {
			_before->keyReleased(sender,event);		
			_after->keyReleased(sender,event);	
		}
		virtual void keyPressed(KeyListenerHaver &sender,KeyEventKeyPressed & event) {
			_before->keyPressed(sender,event);		
			_after->keyPressed(sender,event);		
		}
	};



	
		class KeyListenerHaver {
		private:        
			ListenerHaver<KeyListener,KeyMacroListener > _listenerHaver;


	public:

		KeyListenerHaver() {

		}
	

			void setKeyListener(KeyListener* keyListener) {
				_listenerHaver.setListener(keyListener);
			}

		    
			void addKeyListener(KeyListener* keyListener) {
				_listenerHaver.addListener(keyListener);
			}

			void setKeyListener(KeyListenerPtr keyListener) {
				_listenerHaver.setListener(keyListener);
			}
		    
			void addKeyListener(KeyListenerPtr keyListener) {
				_listenerHaver.addListener(keyListener);
			}
			

			
			void invokeKeyListener(KeyEventKeyReleased &event ) {
				
				typedef void ( KeyListener::*Func)(KeyListenerHaver &, KeyEventKeyReleased  &);
				_listenerHaver.invokeListener<Func,KeyListenerHaver &, KeyEventKeyReleased &>
				(&KeyListener::keyReleased ,*this,event);

			}

			void invokeKeyListener(KeyEventKeyPressed & event) {
				

				typedef KeyListener TT_Listener;
				typedef KeyListenerHaver TT_ListenerHaver;
				typedef KeyEventKeyPressed TT_Event;


				typedef void ( TT_Listener::*Func)(TT_ListenerHaver &, TT_Event  &);
				_listenerHaver.invokeListener<Func,TT_ListenerHaver &, TT_Event &>(&KeyListener::keyPressed ,*this,event);

				
			}

			


			virtual ~KeyListenerHaver () {		}

			


	   
	};


}



#endif
//LISTENER_KEYLISTENER_H
