#ifndef LISTENERHAVER_H
#define LISTENERHAVER_H

//./#include "KeyListener.h"
#include <boost/shared_ptr.hpp>
#include <boost/noncopyable.hpp>
#include "../../global/Debug.h"
#include <vector>


namespace podo{

	struct Enable{
		virtual bool const isEnable() const = 0 ;
	};
 

		
		template < typename LISTENER ,typename MACROLISTENER >
		class ListenerHaver :public boost::noncopyable {
		public:

			typedef  boost::shared_ptr < LISTENER > LISTENERPTR ;
	
		private:



			typedef std::vector<LISTENERPTR> Listeners;
			Listeners _listeners;


		public:			
			ListenerHaver() {				
			}
			virtual ~ListenerHaver() {				
			}


			
			void setListener(LISTENER * listener) {
				LISTENERPTR temp(listener);
				setListener  (temp);
			}

			void setListener(LISTENERPTR listener) {
				_listeners.clear();
				addListener(listener);				
			}

			void addListener(LISTENER * listener) {

				LISTENERPTR temp(listener);
				addListener  (temp);
			}

			void addListener(LISTENERPTR listener) {
				_listeners.push_back(listener);							
			}

			void subListener(LISTENER & listener) {

				LISTENER * toFind = &listener;
				LISTENERPTR toFind_p(toFind);
				typename Listeners::iterator iter = std::find(_listeners.begin(), _listeners.end(), toFind_p);
				toFind_p.release();

				if(iter != _listeners.end()) {
					_listeners.erase(iter);

				}else {

					assertExp(false);

				}
			}

			

			template <typename Func, typename ArgSender, typename ArgEvent>
			void invokeListener(Func  func, ArgSender sender, ArgEvent event) {
				for(std::size_t index = 0; index < _listeners.size() ; ++index) {
					LISTENER & listener = *_listeners[index];
					(listener.*func)(sender,event);

					//(view->*_viewFunc)();
				}

			}			
		

		};


}
#endif
//LISTENERHAVER_H


