/* Generated by Together */

#ifndef LISTENER_SIZELISTENER_H
#define LISTENER_SIZELISTENER_H
//


#include "../../global/Size.h"
#include "../../global/KeyboardKey.h"

#include "ListenerHaver.h"





namespace podo{


	


			
	class SizeEventSizeChanged  {
	public:

		Size _size;
		SizeEventSizeChanged(Size  const &newSize ):_size(newSize) {
		}

	     
	};



 

	class SizeListenerHaver;
	class SizeListener;
	typedef boost::shared_ptr<SizeListener> SizeListenerPtr;
	class SizeListener {
		public:

			virtual ~SizeListener(){}

			virtual void sizeChanged(SizeListenerHaver &sender, SizeEventSizeChanged &event ) = 0;
			

			static SizeListenerPtr createNull();
	};

		

	class SizeAdapter : public SizeListener {

		virtual void sizeChanged(SizeListenerHaver &sender, SizeEventSizeChanged &event ) {}
	};

	class SizeThisListener : public SizeListener {
		        

		SizeListener&  _this;
		
	public:

		SizeThisListener(SizeListener&  this_r) :_this(this_r) { }

		virtual void sizeChanged(SizeListenerHaver &sender, SizeEventSizeChanged &event ) {
			_this.sizeChanged(sender,event);		
		}
		
	};

	class SizeMacroListener : public SizeListener {
		        

		SizeListenerPtr _before;
		SizeListenerPtr _after;
	public:

		SizeMacroListener(SizeListenerPtr before, SizeListenerPtr after) : _before(before), _after(after) { }

		virtual void sizeChanged(SizeListenerHaver &sender, SizeEventSizeChanged &event ) {
			_before->sizeChanged(sender,event);		
			_after->sizeChanged(sender,event);	
		}
		
	};


	
	class SizeListenerHaver {
		private:        
			ListenerHaver<SizeListener,SizeMacroListener > _listenerHaver;

	

	public:

		SizeListenerHaver() {

		}
		void registEnable() {
			
		}

		void setSizeListener(SizeListener* keyListener) {
			_listenerHaver.setListener(keyListener);
		}

		
		void addSizeListener(SizeListener* keyListener) {
			_listenerHaver.addListener(keyListener);
		}

		void setSizeListener(SizeListenerPtr keyListener) {
			_listenerHaver.setListener(keyListener);
		}
		
		void addSizeListener(SizeListenerPtr keyListener) {
			_listenerHaver.addListener(keyListener);
		}
		



	
		void invokeSizeListener(SizeEventSizeChanged &event ) {
			
			typedef void ( SizeListener::*Func)(SizeListenerHaver &, SizeEventSizeChanged  &);
			_listenerHaver.invokeListener<Func,SizeListenerHaver &, SizeEventSizeChanged &>(&SizeListener::sizeChanged ,*this,event);

		}


		virtual ~SizeListenerHaver () {		}

		


	   
	};

}



#endif
//LISTENER_SIZELISTENER_H
