
#ifndef MAPPEDGRAPHICS_HPP_
#define MAPPEDGRAPHICS_HPP_
#include "Brush.h"



namespace podo{
 
    template < typename ORIGINGRAPHICS >
    class MappedInOutGraphics {

    public:
        typedef boost::shared_ptr < ORIGINGRAPHICS > ORIGINGRAPHICSPTR;
        ORIGINGRAPHICSPTR graphics_p;



    private:
        Point pt;



    public:
        MappedInOutGraphics(ORIGINGRAPHICSPTR initInOutGraphics_p, Point initPt) : graphics_p(initGraphics_p), pt(initPt) {

        }



    private:
        Rect mapping(Rect const & rt_r) {
            Rect result(rt_r);
            return result.addPoint(pt);
        }

        Point mapping(Point const & pt_r) {

            return pt_r + pt;
        }

    public:

        Point getMappedPoint() {
            return pt;

        }

        ORIGINGRAPHICSPTR getOriginGraphics() {

            return graphics_p;

        }



    public:

        void drawRect(Rect const & rt) {
            graphics_p->drawRect(mapping(rt));
        }

        void fillRect(Rect const & rt) {
            graphics_p->fillRect(mapping(rt));
        }

        void lineLine(Point const & from, Point const & to) {
            graphics_p->lineLine(mapping(from), mapping(to));
        }

        void print(WString const & string_r, Point const & pt_r) {
            graphics_p->print(string_r, mapping(pt_r));
        }

        void print(WString const & string_r, Rect const & rt_r) {
            graphics_p->print(string_r, mapping(rt_r));
        }

        void setPen(Pen initPen) {
            graphics_p->setPen(initPen);

        }

        void setBrush(Brush initBrush) {
            graphics_p->setBrush(initBrush);
        }

        void operation1();
    };

}
}


#endif
//MAPPEDGRAPHICS_HPP_
